#!/bin/sh

HOME=$DOCUMENT_ROOT/..
. $HOME/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="dic[$$]"

#
#--- Request for original dicom file
#

DIC=${IMAGE_DATA}$PATH_INFO

#--- Transfer original dicom file ---
if [ -f "$DIC" ]; then
  echo Content-type: text/plain
  echo Content-length: `ls -l $DIC | sed -e 's|[ ] *| |g' | cut -f 5 -d ' '`
  echo

  cat $DIC

else
  echo Content-type: text/html
  echo Status: 503
  echo

  echo Not exists: $DIC

  $LOGGER -p $LOG_FACILITY.err -t "$TAG" $DIC not exists
#  echo "`date`: error[$$]: $PATH_INFO" >>$LOG/dic.log

fi
