<%--
 * Parameter:
 *
 * r_no_refresh=true (should not update lastseen)
 * cOp=status|getCells
 *
 * - status query mode (cOp=status)-
 * cStudy: PF's main studyiuid
 * skipNotes: when true the notes will not be collected and returned in the study properties (false by default)
 * 
 * result: JSON object containing a map of local cells in the following format
 *	styiuid -> [status properties object]
 *
 * - cell fetch mode (cOp=getCells) -
 * tlID: ID of the timeline element
 * cStudy: may have multiple values, for each specified study the JSON object used at constructor of TimeLineCell will be returned
 * result: JSON object containing a map of local cells in the following format
 *	styiuid -> [TimeLineCell constructor object]
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%><%@page import="com.erad.pacs.common.libs.RequestInfo,com.erad.pacs.common.interfaces.list.ListDescriptor,com.erad.pacs.connector.Connector,
		com.erad.pacs.app.broker.table.TableBrokerFacade,com.erad.pacs.services.usermanager.tomcat.Sessita,
		imagemed.layout.cache.LayoutCache,imagemed.util.JSHelper,imagemed.layout.*,imagemed.jsputil.JsonObject,imagemed.jsputil.ViewSessionProps.StudyState,
		java.util.*,imagemed.layout.datasource.PatientFolderDataSource"%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();

	response.setContentType( "application/json" );
	response.setHeader( "Pragma", "no-cache" );

	TimeLine tl = null;

	String op = request.getParameter( "cOp" );
	boolean isStatus = "status".equals( op );
	if ( "getCells".equals( op ) ) {
		LayoutRoot root = LayoutCache.getSystemLayout(sess, LayoutPart.PATIENTFOLDERLAYOUT, false, null, null, "true".equals(request.getParameter("cIntegrated")));
		tl = (TimeLine) root.getDescendant( request.getParameter( "tlID" ) );
		if (tl == null) {
			throw new RuntimeException( "TimeLine instance not found in Layout..." );
		}
	}
	else if ( !isStatus ) {
		throw new RuntimeException( "cOp unknown or missing..." );
	}

	String baseStudy = request.getParameter( "cStudy" );
	if ( baseStudy == null || baseStudy.length() == 0 ) {
		throw new RuntimeException( "mainStudy not specified..." );
	}
	boolean skipNotes = "true".equals( request.getParameter( "skipNotes" ) );
	TableBrokerFacade tb = Connector.getInstance().get( TableBrokerFacade.Caller );
	ListDescriptor listDescriptor = tb.getListDescriptor();
	
 	PatientFolderDataSource pfds = new PatientFolderDataSource( sess, listDescriptor, baseStudy, false ); // isRefreshing 

	Map<String, JsonObject> res = new HashMap<String, JsonObject>();
	int n = pfds.getRepeatCount( sess, null );
	for ( int i = 0; i < n; i++ ) {
		pfds.setRepeatPointer( sess, null, i );
		String study = pfds.getValue( sess, "SYUI" );
		res.put( study, isStatus ? new StudyState( study, sess, !skipNotes ) : ( tl.new TlCellDesc( sess, new RequestInfo(request), pfds ) ) );
	}
%><%=JSHelper.toJSON( res )%>