<%--
 * Component: cases
 *
 * Description:
 *  Popup window which unlocks study when the user leaving a HTML page which creates study lock.
 *
 * Parameters:
 *
 *   study             Study Instance UID	(single study mode)
 *   cIMLockID         Lock ID
 *								OR							
 *	 cContext					 context containing cLockedStudies	(multiple studies mode)
 *
 * Last Updated     : $Author: rty $
 * Update Date Time : $Date: 2013/12/11 17:39:48 $
 * RCS File Name    : $RCSfile: unlockwindow.jsp,v $
 * RCS Revision     : $Revision: 1.26 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
 *
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,java.sql.*,java.util.*,imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();
	
	if ( "true".equals( request.getParameter( "cProxy" ) ) ) {
		Properties rspHeaders = new Properties();
		String host = null; // "autodetect" parent
		String pageUrl = "/cases/unlockwindow.jsp";
		String postData = Helper.replace( Helper.replace( request.getQueryString(), "&cProxy=true", "" ), "cProxy=true&", "" );
		String body = Proxy.issueProxyURL( sess, host, pageUrl, postData, rspHeaders );
		out.println( body );
		Helper.writeTextFile( "/tmp/redirect1.txt", body + "\n\n" + Helper.props2String( rspHeaders ) );
		for ( Enumeration<?> headers = rspHeaders.keys(); headers.hasMoreElements(); ) {
			String header = ( String ) headers.nextElement();
			response.setHeader( header, rspHeaders.getProperty( header ) );
		}
		return;
	}
%><HTML><HEAD><TITLE>Release Study</TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( response.getWriter() );
%>
</head>
<body>
<center><BR>Unlocking study ...<BR><BR></center>

<%

Context context = new Context(sess, request);

String parStudy = request.getParameter( "study" );

	String[] ps = context.getValues( "cLocks" );

	// cInstant is only checked if cLocks was provided.
	// cLocks originally was used by batch approve and 
	// without cInstant, releasing study locks is delayed to work-around network issues
	// However in most cases locks need to be released instantly.
	boolean isInstant = "true".equals( request.getParameter( "cInstant" ) );
	
	String backPar = request.getParameter( "cBack" );
	String backURL = request.getParameter( "cBackURL" );
	
	
	
	if ( parStudy != null && parStudy.length() > 0 ) {
		
		AkacFacade.unlockStudy( sess, parStudy, IMLock.getLockIDFromRequest( sess, request, parStudy ) );
	}

	if ( ps != null && ps.length > 0 ) {
		if ( isInstant ) {
			BatchApproveToolbox.doInstantUnlocking( sess, ps );
		}
		else {
			BatchApproveToolbox.startUnlocking( sess, ps );
		}
/*		for ( int i=0; i<parStudies.length; i++ ) {
	Helper.DEBUG( "unlockWindow", "unlocking " + parStudies[ i ] );
	  	Helper.DEBUG( "unlockWindow", "returned "+IMLock.lockStudy( is, parStudies[ i ], "Unlock", new Properties() ) );
		}*/
	}
%>
<script language="JavaScript">
<%
	if ( backURL != null && backURL.length() > 0 ) {
%>
	document.location.href="<%=backURL%>";
<%
	}
	else if ( backPar == null ) {
%>
	window.close();
<%
	}
	else {//may be replaced with real back parameters if needed...
%>
	history.back();
<%
	}
%>
</script>
</body>
</html>
