<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@page import="imagemed.types.string.IMTypeiS"%>
<%@page import="java.sql.ResultSet"%>
<%@page import="com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl"%>
<%@page import="java.sql.Statement"%>
<%@page import="imagemed.dotcom.DotcomConfig"%><%--
 ** Component: cases
 **
 ** Uploads an attachment and attach it to DICOM (Study) 
 **
 ** 	@param userfile			the Multipart containing the attachment
 **												the original filename must be xxx_1, ( or xxx_2, xxx_3, etc. in case of multiple pages)
 **		@param cStudyIUID		the Study UID, if null, "generatedUID" will be used
 **                       in case of PACSorder we got fake study UID in it,
 **		@param cSeriesUID  	Series Instance UID of the series the image to be attached to
 **		@param cPDF					if "true" attachment(s) will be converted to PDF (default: false)
 **		@param numpages			the number of total pages (1,2, ...) this attachment conatins
 **		@param cDocType 		the document type (display name, not inner ID!) of the attachment
 **   @param cObjType     the type of the object scanned to, may be: 'study', 'PACSorder', 'order'
 **		@param cIsImage			if 'true' attachment is Image-type: should be add to dicom as an image instead of attachment
 **   @param id           in case of order (Scheduler) we got ORDERNUM in it.
 **   @param cModality    for Image types: Modality value
 **   @param cStudyDate   for Image types: Study Date value - Date part (YYYYMMDD or "")
 **   @param cStudyTime   for Image types: Study Date value - Time part (HHMMSS or "")
 **   @param cUploadOnly  if 'true' this is an upload-only (upload button) call - savename is used
 **   @param savename			in case of cUploadOnly, this contains the 'name-to-save', actually used for deciding if JPG or PDF 
 **
 **   @return							"FILE:" + name of the uploaded file, if successful
 **
--%><%@page import="imagemed.scheduler.SchedulerInterface"%>
<%@page import="java.util.Properties"%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,imagemed.exception.*"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%@page import="java.io.File"%>
<%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="com.erad.pacs.app.broker.table.internals.TableImpl"%><%
	Sessita sessita = Sessita.Create( request, response );

	response.setContentType("text/plain");

%><%@
	page import="java.util.List"%><%@
	page import="java.util.ArrayList"%><%
//DEBUG
/*
	ServletInputStream isstream = request.getInputStream();
	File fLoginDir = new File(IMEnv.getEnv("ATTACHMENT_DATA"));
	File fVidFile = File.createTempFile(""+System.currentTimeMillis(),".sca", fLoginDir );
	FileOutputStream ostream = new FileOutputStream(fVidFile);
	byte buffer[] = new byte[2048];
	int nRead;

	while (-1 != (nRead = isstream.read(buffer))) {
				ostream.write(buffer, 0, nRead);
	}

	isstream.close();
	ostream.close();
	
	if( true )
		return;
*/	
	
/*
 filenames (genaFileName): valami_1, valami_2
 tmpFileName: mindig ua. MIPTEST.JPG pl.
*/

	MultipartRequest mp = new MultipartRequest( request, AttachmentManager.getTempDir() );
	String tmpFileName = mp.getParameter("userfile");
	String numPages = mp.getParameter("numpages");
	String genaFileName = mp.getFileNameFor("userfile");
	String studyIUID = mp.getParameter("cStudyIUID");
//	String seriesID = mp.getParameter("cSeriesID");
	String seriesUID = mp.getParameter("cSeriesUID");
	boolean isPDF = "true".equals( mp.getParameter("cPDF") );

	String proposedStudyUID = mp.getParameter("cProposedStudyUID");
	
	boolean isImage = "true".equals( mp.getParameter("cIsImage") );
	String objType = mp.getParameter("cObjType");
	String orderNum = mp.getParameter("id");
	String studyDate = mp.getParameter("cStudyDate");
	String studyTime = mp.getParameter("cStudyTime");
	String modality = mp.getParameter("cModality");

	//this doctype is the displayed one, we convert it to inner id
	String docType = mp.getParameter( "cDocType" );
	if( docType != null ) {
		docType = AttachmentManager.getDoctypeIDFromDisplayName( docType );
	}

	// if it's an uploaded PDF we will simply call attachPDF instead of attachSC
	boolean isUploadOnly = "true".equals( mp.getParameter("cUploadOnly") );
	boolean isUploadedPdf = false;
	if( isUploadOnly ) {
		String saveFileName = mp.getParameter("savename");
		if( saveFileName != null && saveFileName.toLowerCase().endsWith( ".pdf" ) ) {
			isUploadedPdf = true;
			Helper.DEBUG( "DicomUpload", "uploadedPDF:" + saveFileName );
		}
	}
	
	Helper.DEBUG( "DicomUpload CALLED", "genafilename:" + genaFileName );
	Helper.DEBUG( "DicomUpload", "tmpfilename:" + tmpFileName );

	String targetHUB = mp.getParameter("cTargetHUB");

	//ez itten azt jelenti, hogy minden serverre el fogja kuldeni a multipart-ot, de ezzel nem tudunk mit tenni...

	Helper.DEBUG( "DicomUpload", "targetHUB:" + targetHUB );

	if( targetHUB != null && !"".equals( targetHUB ) && !targetHUB.equals( DotcomConfig.selfId() ) ) {
		//redirect, multi params are not needed, they will be included in writeMultipartBodyTo
		String device = DotcomConfig.getConfig().getServerNameTowards( targetHUB );
		if( device != null ) {
			String idBase = RedirectToolbox.getURL( device, sessita.getSession().getClientAddress().getHostAddress(), null );
			if( idBase != null && !"".equals( idBase ) ) {
				StringBuilder sb = new StringBuilder( idBase );
				sb.append( "/cases/uploadDicom.jsp" );
				Helper.DEBUG( "DicomUpload redirected to:" + sb.toString() );
				response.sendRedirect( sb.toString() );
				return;
			}
		}
	}

	
	boolean logging = true;
	int multipleNum = -1;
	boolean isMultiPage = false;
	int numPagesInt = 0;
	try {
		numPagesInt = Integer.parseInt( numPages );
	}
	catch ( Exception e ) {
	}

	if( numPagesInt > 1 ) {
		isMultiPage = true;
		multipleNum = AttachmentManager.nameMultiple( genaFileName );
		if( numPagesInt != multipleNum ) {
			logging = false;
		}
	}
	

	String actdir;
	if( studyIUID != null ) {
		actdir = AttachmentManager.getTempDir() + "/" + studyIUID;
	}
	else {
		if( "order".equals( objType ) ) {
			if( orderNum == null ) {
				Helper.ERRORLOG( "DicomUpload: orderNum is null!");
				orderNum = "generatedOrderNum";
			}
			actdir = AttachmentManager.getTempDir() + "/" + orderNum;
		}
		else {
			Helper.ERRORLOG( "DicomUpload: studyIUID is null!");
			studyIUID = "generatedUID";
			actdir = AttachmentManager.getTempDir() + "/" + studyIUID;
		}
	}
	
	String seriesNumber = AttachmentManager.getSeriesNumber( studyIUID, docType, seriesUID );

	
	Helper.DEBUG( "DicomUpload", "studyIUID:" + studyIUID );
	Helper.DEBUG( "DicomUpload", "seriesNumber:" + seriesNumber );
	Helper.DEBUG( "DicomUpload", "seriesUID:" + seriesUID );
	Helper.DEBUG( "DicomUpload", "numpages:" + numPages );
	Helper.DEBUG( "DicomUpload", "multipleNum:" + multipleNum );
	Helper.DEBUG( "DicomUpload", "isimage:" + isImage );
	Helper.DEBUG( "DicomUpload", "objtype:" + objType );
	Helper.DEBUG( "DicomUpload", "orderNum:" + orderNum );
	

	if( tmpFileName == null ) {
		Helper.ERRORLOG("No temporary file created in upload!");
		out.println("No temporary file created in upload!");
		return;
	}

	File tmpFile = new File( tmpFileName );
	if( !tmpFile.exists() ) {
		Helper.ERRORLOG( "DicomUpload", "Tmp File Not Found!" );
		out.println("Tmp File Not Found!");
		return;
	}
	else {
		Helper.DEBUG( "DicomUpload", "Tmp File Found!" );
		if( tmpFile.length() == 0 ) {
			Helper.DEBUG( "DicomUpload", "Tmp File is empty!" );
		}

		//create sub-dir if needed
		if( !isMultiPage || multipleNum == 1 ) {
			File actdirFile = new File( actdir );
			if ( !actdirFile.exists() ) {
				if ( !actdirFile.mkdirs() ) {
					Helper.ERRORLOG( "Couldn't create directory " + actdir + " in DicomUpload" );
					out.println( "Couldn't create directory " + actdir + " in DicomUpload" );
					return;
				}
			}
		}
		
		List<String> cmd = new ArrayList<String>();
		boolean doPDF = false;
		boolean doSC = false;
		
		if( isPDF ) {
			String pdfName = actdir + "/attach.pdf";
			if( isMultiPage ) {
				Helper.DEBUG( "DicomUpload", "Multipage PDF" );
				
				//rename tmp file to genaFilename (_0 , _1 ...)
				String countedTempFileName = actdir + "/" + AttachmentManager.getRelativeName( genaFileName );
				if( !( Helper.renameToNotThrowsException( tmpFile, new File( countedTempFileName ) ) ) ) {
					Helper.ERRORLOG( "Couldn't rename temp file: " + tmpFileName + " to " + countedTempFileName );
					out.println( "Couldn't rename temp file: " + tmpFileName + " to " + countedTempFileName );
					return;
				}

				Helper.DEBUG( "DicomUpload", "mulNum: " + multipleNum + ", numPagesInt: " + numPagesInt );

				if( multipleNum == numPagesInt ) { //last page
					//convert all to 1 pdf
					AttachmentManager.convertToPDF( actdir + "/" + AttachmentManager.getBaseName( genaFileName ) + "*", pdfName, false );

					// delete temps
					AttachmentManager.deleteTempsByName( genaFileName, actdir, numPagesInt );
					
					//and call attachPDF
					doPDF = true;
				}
			}
			else {
				//convert to PDF, also delete temp
				AttachmentManager.convertToPDF( tmpFileName, pdfName, true );
				
				//and call attachPDF
				doPDF = true;
			}
			if( doPDF ) {
				//attach PDF into DICOM
				if( "order".equals( objType ) ) {
					studyIUID = AttachmentManager.getStudyIUIDForOrder( orderNum );					
				}
				else if( "PACSorder".equals( objType ) ) {
					if( proposedStudyUID == null || "".equals( proposedStudyUID ) ) {
						Helper.ERRORLOG( "Proposed Study UID is null or empty for:" + studyIUID );
					}
					else {
						studyIUID = proposedStudyUID;
					}
				}
				
				if( studyIUID == null ) {
					Helper.ERRORLOG( "Study UID is NULL! - no attachPDF" );
				}
				else {
					cmd.clear();
					cmd.add( IMEnvBase.getEnv( "SR_HOME" ) + "/bin/attachPdf" );
					cmd.add( "-s" );
					cmd.add( studyIUID );
					if( seriesUID != null ) {
						cmd.add( "-e" );
						cmd.add( seriesUID );
					}
					if( seriesNumber != null ) {
						cmd.add( "-n" );
						cmd.add( seriesNumber );
					}
					cmd.add( "+t" );
					cmd.add( "ScannedPDF" );
					if( docType != null ) {
						cmd.add( "-t" );
						cmd.add( docType );
					}
					if( studyDate != null ) {
						cmd.add( "+Dd" );
						cmd.add( studyDate );
					}
					if( studyTime != null ) {
						cmd.add( "+Dt" );
						cmd.add( studyTime );
					}
					if( modality != null ) {
						cmd.add( "+Dm" );
						cmd.add( modality );
					}
					if( isImage ) {
						cmd.add( "+Ao" );
					}
					cmd.add( pdfName );
					
					Helper.DEBUG( "DicomUpload", "Command (PDF): " + cmd.toString() );
	
					RunCommandResult runResult = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ), null );
					if ( runResult != null && runResult.getExitCode() != 0 ) {
						Helper.ERRORLOG( "Couldn't execute command: " + cmd.toString() + ", Error message: " + runResult.getError() );
						out.println( "Couldn't execute command: " + cmd.toString() + ", Error message: " + runResult.getError() );
						return;
					}	
					
					Helper.DEBUG( "DicomUpload", "Command executed" );
				}
				
				//delete PDF
				File pdfFile = new File( pdfName );
				if( !pdfFile.delete() ) {
					Helper.ERRORLOG( "DicomUpload", "Couldn't delete PDF file: " + pdfName );
				}
				
			}
			Helper.DEBUG( "DicomUpload", "jsp end" );
		}
		else { // JPG or maybe PDF which was uploaded
			List<String> names = new ArrayList<String>();
			if( isMultiPage ) {
				Helper.DEBUG( "DicomUpload", "Multipage JPG" );
				
				//rename tmp file to genaFilename (_0 , _1 ...)
				String countedTempFileName = actdir + "/" + AttachmentManager.getRelativeName( genaFileName );
				if( !( Helper.renameToNotThrowsException( tmpFile, new File( countedTempFileName ) ) ) ) {
					Helper.ERRORLOG( "Couldn't rename temp file: " + tmpFileName + " to " + countedTempFileName );
					out.println( "Couldn't rename temp file: " + tmpFileName + " to " + countedTempFileName );
					return;
				}

				Helper.DEBUG( "DicomUpload", "mulNum: " + multipleNum + ", numPagesInt: " + numPagesInt );

				if( multipleNum == numPagesInt ) { //last page
					//get name of temps
					String ext = AttachmentManager.getExtension( genaFileName );
					String fileNameBase = actdir + "/" + AttachmentManager.getBaseName( genaFileName );
					for( int i = 0; i < numPagesInt; i++ ) {
						String actFileName = fileNameBase + "_" + i + ext;
						names.add( actFileName );
					}
					doSC = true;
				}
			}
			else {
				names.add( tmpFileName );
				doSC = true;
			}
			
			if( doSC && !names.isEmpty() ) {
				if( "order".equals( objType ) ) {
					studyIUID = AttachmentManager.getStudyIUIDForOrder( orderNum );					
				}
				else if( "PACSorder".equals( objType ) ) {
					if( proposedStudyUID == null || "".equals( proposedStudyUID ) ) {
						Helper.ERRORLOG( "Proposed Study UID is null or empty for:" + studyIUID );
					}
					else {
						studyIUID = proposedStudyUID;
					}
				}
				
				if( studyIUID == null ) {
					Helper.ERRORLOG( "Study UID is NULL! - no attachSC" );
				}
				else {
					cmd.clear();
					if( isUploadedPdf ) {
						cmd.add( IMEnvBase.getEnv( "SR_HOME" ) + "/bin/attachPdf" );
					}
					else {
						cmd.add( IMEnvBase.getEnv( "SR_HOME" ) + "/bin/attachSC" );
					}
					cmd.add( "-s" );
					cmd.add( studyIUID );
					if( seriesUID != null ) {
						cmd.add( "-e" );
						cmd.add( seriesUID );
					}
					if( seriesNumber != null ) {
						cmd.add( "-n" );
						cmd.add( seriesNumber );
					}
					if( isUploadedPdf ) {
						cmd.add( "+t" );
						cmd.add( "UploadedPDF" );
					}
					else {
						cmd.add( "+d" );
						cmd.add( "ScannedJPEGImage" );
					}
					if( docType != null ) {
						cmd.add( "-t" );
						cmd.add( docType );
					}
					if( studyDate != null ) {
						cmd.add( "+Dd" );
						cmd.add( studyDate );
					}
					if( studyTime != null ) {
						cmd.add( "+Dt" );
						cmd.add( studyTime );
					}
					if( modality != null ) {
						cmd.add( "+Dm" );
						cmd.add( modality );
					}
					if( isImage ) {
						cmd.add( "+Ao" );
					}
/*			
					if( multipleNum != -1 ) {
						cmd.add( "-m" );
						cmd.add( "" + ( multipleNum ) );
					}
*/
					for( int i = 0; i < names.size(); i++ ) {
						String name = names.get( i );
						if( name != null ) {
							cmd.add( name );
						}
					}
		
					Helper.DEBUG( "DicomUpload", "Command: " + cmd.toString() );
		
					//env is null: all environment variables will be reachable at the C++ code
					RunCommandResult runResult = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ), null );
					if ( runResult.getExitCode() != 0 ) {
						Helper.ERRORLOG( "Couldn't execute command: " + cmd.toString() + ", Error message: " + runResult.getError() );
						out.println( "Couldn't execute command: " + cmd.toString() + ", Error message: " + runResult.getError() );
						return;
					}	
		
					Helper.DEBUG( "DicomUpload", "Command executed" );
					
					if( isMultiPage ) {
						// delete temps
						AttachmentManager.deleteTempsByName( genaFileName, actdir, numPagesInt );
					}
				}
			}
			
			if( !isMultiPage ) {
				if( !tmpFile.delete() ) {
					Helper.ERRORLOG( "DicomUpload", "Couldn't delete tmp file: " + tmpFileName );
				}
	
				Helper.DEBUG( "DicomUpload", "tmp file deleted" );
			}

			//delete sub-dir if needed
			if( !isMultiPage || multipleNum == numPagesInt ) {
				Helper.removeDirectoryRecursively( actdir );
			}

			Helper.DEBUG( "DicomUpload", "jsp end" );

		}
		
		if( logging ) {
			OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "Scan/Upload" );
			Syslog operLogger = new Syslog( "uploadDicom.jsp", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
			logEntry.setField( OperLogEntry.FIELD.USER, sessita.getSession().getUser().getUserId() );
			if( studyIUID != null ) {
				logEntry.setBasicStudyFields(sessita.getSession(), studyIUID );
			}
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, "Original file name:" + genaFileName +  " , Series Number:" + seriesNumber + " , type:" + ( isPDF || isUploadedPdf ? "PDF": "JPG" ) + " , No. of pages:" + ( numPages == null ? "1" : numPages ) );
			logEntry.log(sessita.getSession(), operLogger, Syslog.LOG_INFO );

/*			
			Properties logFields = new Properties();
			logFields.setProperty( "0LAC", "Scan/Upload" );
			if( studyIUID != null ) {
				OperLogEntry.makeLogFieldsFromStudyOrPACSOrder( is, studyIUID, logFields, null );
			}
			logFields.setProperty("0LIN", "Series Number:" + seriesNumber + " , type:" + ( isPDF ? "PDF": "JPG" ) + " , No. of pages:" + numPages );
			SchedulerInterface.logIntoTable( is, logFields );
*/			
		}
		
		out.println( "FILE:" + tmpFileName ); //means OK
	}
%>