<%--
 * Component: cases
 *
 * Description:
 *    Listing and manipulating user folders
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.MissingSession"%>
<%@page import="com.erad.pacs.app.broker.table.internals.TableImpl"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="imagemed.types.flag.IMTypeur"%><%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%@

  page import="imagemed.imsession.*,imagemed.util.*, imagemed.jsputil.*,imagemed.license.*,
 		imagemed.exception.*,java.io.*,imagemed.types.flag.IMTypeur,imagemed.http.Range"
%><%
	Sessita sessita = Sessita.Create( request, response, MissingSession.NOTHROW );
	Session sess = sessita.getSession();
	
	Helper.DEBUG( "viktorsession:" + Helper.toString(sess) );
%><%
	MultipartRequest req = new MultipartRequest( request, IMEnvBase.getEnv( "TMP" ) );
	String opValue = req.getParameter( "op" );
	if ( "uploadLic".equals( opValue ) ) {
		// MODE: license is uploaded, save it
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "uploadlicense" );

		if (null != sess) {
			logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
			logEntry.setField( OperLogEntry.FIELD.HOST, sess.getClientAddress().getHostAddress() );
		} else {
			logEntry.setField( OperLogEntry.FIELD.USER, "unknown" );
			logEntry.setField( OperLogEntry.FIELD.HOST, request.getRemoteAddr() );
		}
		
		String fileName = req.getParameter( "New" );
		if ( fileName == null ) {
			throw new IMGeneralException( "Missing parameter: No valid file selected! (1)", "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadlicense.jsp" );		 
		}
		File licenseXML = new File( fileName );
		Helper.DEBUG( "licensefilename:" + fileName );
		if ( !licenseXML.exists() || licenseXML.length() == 0 ) {
			throw new IMGeneralException( "Missing parameter: No valid file selected! (2)", "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadlicense.jsp" );
		}

		// check if valid license file 
		eRADLicense lic = new eRADLicense( eRADLicenseRequest.VALUE_UNKNOWN );
		try {
			lic.createFromXML( fileName );
		}
		catch( Exception e ) {
			Helper.ERRORLOG( "Error parsing license file:" + Helper.throwable2String( e ) );
			throw new IMGeneralException( "The uploaded file is not a valid eRAD PACS license file.", "imadmin/srvinfo.jsp", "Upload problem", "/cases/uploadlicense.jsp" );
		}
		String type = lic.m_props.getProperty( eRADLicenseRequest.PROP_TYPE );
		String savename = IMEnvBase.getEnv( "VAR" ) + "/";
		if( eRADLicenseRequest.VALUE_LICENSE.equals( type ) )	{
			savename += eRADLicense.NAME_LICENSE; 
		}
		else if( eRADLicenseRequest.VALUE_CHANGE.equals( type ) )	{
			savename += eRADLicense.NAME_CHANGE;
		}
		else if( eRADLicenseRequest.VALUE_EXTENSION.equals( type ) )	{
			savename += eRADLicense.NAME_EXTENSION;
		}
		else {
			throw new IMGeneralException( "Couldn't identify license type", "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadlicense.jsp" );
		}
		
		if( Helper.renameTo( licenseXML, new File( savename ) ) ) {
			if( eRADLicenseRequest.VALUE_LICENSE.equals( type ) )	{
				File changeFile = new File( IMEnvBase.getEnv( "VAR" ) + "/" + eRADLicense.NAME_CHANGE );
				if( changeFile.exists() ) {
					changeFile.delete(  );
				}
			}
			if( eRADLicenseRequest.VALUE_LICENSE.equals( type ) ||
					eRADLicenseRequest.VALUE_CHANGE.equals( type ) ) {
				File extFile = new File( IMEnvBase.getEnv( "VAR" ) + "/" + eRADLicense.NAME_EXTENSION );
				if( extFile.exists() ) {
					extFile.delete(  );
				}
			}
			TabBean.checkLicense( true );
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, ( eRADLicenseRequest.VALUE_LICENSE.equals( type ) ? "new" : type ) + " license uploaded" );
			logEntry.log( sess, "uploadlicense.jsp", 0, Syslog.LOG_INFO );
		}
		else {
			throw new IMGeneralException( "Couldn't rename the license file to:" + savename, "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadlicense.jsp" );
		}

%>
		<center><font size="4">
		<%=LocalizedMessage.getSimpleMessage( "IMADMIN_SRVINFO_LICENSE_UPLOADED" ) %>	
		</center>
<script language="JavaScript">
		setTimeout( "document.location='/Evo/';", 3000 );
</script>
</BODY>
</HTML>
<%		
		return;
	}

	// MODE: first time here, get the license upload form 
%>
<HTML><HEAD><TITLE>Create License</TITLE><%
  TableImpl.printCommonScript( response.getWriter() );
%>
	<script language="JavaScript">
		function doUpload() {
			var frm = self.document.uploadForm;
			while (frm.cFileName.value != frm.New.value) {
				frm.cFileName.value = frm.New.value;
			}
			frm.submit();
		}
	</script>
</HEAD>
<BODY>
 <CENTER><H3>Select the License file (provided by eRad support)</H3>
<%
	out.println( LicenseToolbox.getUploadLicenseForm() ); 
%>

</BODY>
</HTML>


