#!/bin/sh
#
# cddetect.sh device
#

. ~/etc/setenv.sh

[ -f "${CD_VAR}/cdwriter.cfg" ] && . ${CD_VAR}/cdwriter.cfg

[ -z "${WRITER_DEV}" ] && WRITER_DEV="0,0,0"

ID=$1
OUT="${TMP}/mediasession/mediasession_${ID}/cddetect.log"

sudo cdrecord -atip dev=${WRITER_DEV} |grep "Is erasable" >$OUT
sudo cdrecord -atip dev=${WRITER_DEV} |grep "ATIP start of lead out" >>$OUT
sudo cdrecord -toc dev=${WRITER_DEV} |grep "first:" >>$OUT
echo "done." >>$OUT
