<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cd
 *
 * Description:
 *   Start creating a DICOM Media
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="imagemed.jsputil.IMAdminToolbox"%>
<%@page import="imagemed.jsputil.OperToolbox"%>
<%@page import="imagemed.jsputil.CDBurnToolbox"%>
<%@page import="imagemed.jsputil.TabToolbox"%>
<%@page import="imagemed.imsession.IMSession"%>
<%@
	page import="imagemed.util.*,imagemed.dicom.*,imagemed.exception.*,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
		java.sql.*,java.io.*,java.util.*,imagemed.http.tabs.*, java.text.Format"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static String TAB_PAGE = "cases/index.jsp";

	static void printRefreshPage( IMSession is, MessageBox mb, String refreshURL, String backURL ) throws Exception {
		String title = LocalizedMessage.getSimpleMessage( "CD_BURNCD_BURNER_NULL" );
		is.out.print( "<HTML><HEAD><TITLE>" );
		is.out.print( Helper.htmlEncode( title ) );
		is.out.println( "</TITLE>" );
		is.out.println( "<meta http-equiv=\"Content-Type\" content=\"text/html\">" );
		is.out.println( "<meta http-equiv=\"Pragma\" content=\"no-cache\">" );
		TabToolbox.writeIMpopup( is.out );
		com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( is );
		
		CDBurnToolbox.printMediaListScripts( is, refreshURL );
		
		is.out.println( "</HEAD><BODY><center>" );
		TabToolbox.makeTabs( is, is.tabbean, TAB_PAGE, "White" );

		is.out.println( "<BR>" );
		mb.print( is.out );

		is.out.println( "<BR>" );
		CDBurnToolbox.printMediaListTable( is, refreshURL, backURL );

		is.out.println( "</center></BODY></HTML>" );
	}



%><%
	IMSession is = new IMSession( request, response, out ); 

	if ( !is.regOK() ) {
		return;
	}

	if ( !is.tabbean.hasLicense( is, "8" ) ) {
		out.println( LocalizedMessage.getSimpleMessage( "EXCEPTION_CD_BURNCD_NO_LICENSE" ) );
		return;
	}
	
	String parStudies[] = request.getParameterValues( "cGr" );
	
	String parBack = request.getParameter( "cBack" );
	if (null == parBack) {
		parBack = request.getHeader( "Referer" );
	}
	if (null == parBack) {
		parBack = "javascript:self.history.back();";
	}
	
	String backLink = "cBack=" + Helper.URLEncodeUTF8( parBack );
	
	String parStSize = request.getParameter( "cStSize" );
	String parProfileUser = request.getParameter( "profileUser" );

	Helper.DEBUG( "profileuser:" + parProfileUser );
	
	boolean saveAsDefault = "true".equals( request.getParameter( "cSetDefault" ) );

	UserPreferences prefs = new UserPreferences( is.regID );
	prefs.load();
	prefs.processForm( is , new String[] { "burn_media_type", "burn_compression", "burn_add_viewer", "burn_omit_sr", "burn_profile_user"} );
	
	if ( saveAsDefault ) {
		// Save compression parameters as default
		prefs.save();
	}
	
	String mediaType = prefs.getPreference( "burn_media_type" );
	String compression = prefs.getPreference( "burn_compression" );
	boolean addViewer = "true".equals( prefs.getPreference( "burn_add_viewer" ) );
	boolean omitSR = "true".equals( prefs.getPreference( "burn_omit_sr" ) );


	DicomMediaSession.MCSResult limitResult = DicomMediaSession.checkLimits();
	if ( limitResult.getLimitType() != DicomMediaSession.MCSLimit.NONE ) {
		StringBuilder msg = new StringBuilder( 256 );
		if ( limitResult.getLimitType() == DicomMediaSession.MCSLimit.RUNNING ) {
            msg.append( LocalizedMessage.getCompoundMessage( "CD_BURNCD_SESSION_RUNNING_LIMIT_EXCEEDED", new Format[] { null }, new Object[] { DicomMediaSession.MAX_IN_PROCESS }, true ) );
		}
		else if ( limitResult.getLimitType() == DicomMediaSession.MCSLimit.COUNT ) {
            msg.append( LocalizedMessage.getCompoundMessage( "CD_BURNCD_SESSION_TOTAL_LIMIT_EXCEEDED", new Format[] { null }, new Object[] { DicomMediaSession.MAX_BURN }, true ) );
		}
		else { // ( limitResult.getLimitType() == DicomMediaSession.MCSLimit.SPACE )
			msg.append( LocalizedMessage.getCompoundMessage( "CD_BURNCD_DISK_LIMIT_EXCEEDED", new Format[] { null }, new Object[] { DicomMediaSession.MAX_SPACE }, true ) );
		}

		String resourceMsg = LocalizedMessage.getSimpleMessage( "CD_BURNCD_WAIT_SYS_RESOURCE_MSG" );
		msg.append( "<BR>" );
		msg.append( resourceMsg );

		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "BURN_ERROR_TITLE" ), "80%" );
		mb.setMessage( msg.toString() );
		
		mb.addButton( new Button( parBack, "BUTTON_CANCEL", "BUTTON_NULL" ) );

		StringBuilder refreshURL = new StringBuilder( 256 );
		refreshURL.append( "createMedia.jsp" );
		refreshURL.append( "?" ).append( UserPreferences.getFormName( "burn_media_type" ) ).append( "=" ).append( mediaType );
		refreshURL.append( "&" ).append( UserPreferences.getFormName( "burn_compression" ) ).append( "=" ).append( compression );
		if ( addViewer ) {
			refreshURL.append( "&" ).append( UserPreferences.getFormName( "burn_add_viewer" ) ).append( "=true" );
		}
		if ( omitSR ) {
			refreshURL.append( "&" ).append( UserPreferences.getFormName( "burn_omit_sr" ) ).append( "=true" );
		}
		if ( parStudies != null ) {
			for ( String study : parStudies ) {
				refreshURL.append( "&cGr=" ).append( study );
			}
		}
		refreshURL.append( "&cBack=" ).append( Helper.URLEncodeUTF8( parBack ) );
		if ( parStSize != null ) {
			refreshURL.append( "&cStSize=" ).append( Helper.URLEncodeUTF8( parStSize ) );
		}
		
		printRefreshPage( is, mb, refreshURL.toString(), parBack );
		return;
	}
	
	String titleMsg = LocalizedMessage.getSimpleMessage( "CD_BURNCD_BURNER_NULL" );

	
	OperToolbox.InfoTable infoTable = OperToolbox.getPatientNames( parStudies, is );
	String studiesTable = infoTable.getStudiesTable();

	TreeMap<String, DicomMediaCreator.StudySubSet> vStudies = null;
		if ( parStudies != null ) {
		vStudies = new TreeMap<String, DicomMediaCreator.StudySubSet>();
		for ( String study : parStudies ) {
			vStudies.put( study, new DicomMediaCreator.StudySubSet() );
		}
	}
	
	DicomMediaCreator.IncludeReports includeReports = omitSR ? DicomMediaCreator.IncludeReports.FALSE : DicomMediaCreator.IncludeReports.AUTO;  
	
	DicomMediaCreator mediaCreator = new DicomMediaCreator( is.regID, vStudies, mediaType, compression, addViewer, includeReports );
	if( parProfileUser != null && !"".equals( parProfileUser ) ) {
		mediaCreator.setProfileUser( parProfileUser );
	}
	mediaCreator.start();
	
	String id = mediaCreator.getId();
	String ext = mediaCreator.getExtension();

	String name = "dcm" + id + "." + ext;
	String mode = "zip".equals( ext ) ? "EXTRACT" : "OPEN";
	String label = LocalizedMessage.getSimpleMessage( "zip".equals( ext ) ? "APPLET_DICOM_EXPORT_LABEL_ZIP" : "APPLET_DICOM_EXPORT_LABEL_ISO" );


%><HTML><HEAD>
<meta http-equiv="Content-Type" content="text/html">
<meta http-equiv="Pragma" content="no-cache">
<%

// imagemed.http.tabs.TabBean.writeStyleOnly(is);
TabToolbox.writeIMpopup(out);
com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);

JSHelper.printJsInclude( out, JSHelper.RGBCOLOR_JS );
JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );
%>
<SCRIPT language="JavaScript">

	var isDownloaded = false;
	var checkUnload = true;

<%
	CDBurnToolbox.printProgressJS( out );
%>

	function jump( url ) {
		document.location = url;
	}


	function showApplet() {
		var appletPanel = document.getElementById( 'appletpanel' );
		appletPanel.style.visibility = "visible";
	}

	function showButtons( isOK ) {
		var buttonsPanel = document.getElementById( 'buttonsPanel' );
		buttonsPanel.style.visibility = "visible";
		
		if ( isOK ) {
			var burnOnServerButton = document.getElementById( 'burnOnServer' );
			if ( burnOnServerButton != undefined ) {
				burnOnServerButton.style.visibility ="visible";
			}
		}
	}

	function showCreateProgress() {
		var progressDiv = document.getElementById( 'progressCreateDiv' );
		progressDiv.style.visibility = "visible";
	}

	function showError( errMsg ) {
		var progressDiv1 = document.getElementById( 'progressCollectDiv' );
		var progressDiv2 = document.getElementById( 'progressCreateDiv' );
		var progressTR = document.getElementById( 'progressTR' );
		var errorDiv = document.getElementById( 'progressErrorDiv' );

		progressDiv1.style.visibility = "hidden";
		progressDiv2.style.visibility = "hidden";
		progressTR.style.visibility = "collapse";
		errorDiv.style.visibility = "visible";
		errorDiv.innerHTML = errMsg;		
	} 

	
   function getProgressInfo() {
		$.getJSON( "/cd/progressInfo.jsp?cID=<%= id %>&timestamp=" + ( new Date() ).getTime(),
			function( res ) {
				if ( typeof res == 'string' ) {
					alert( "fetching remote Studies failed: " + res );
					return;
				}

				if ( res.isComplete ) {
					if ( res.isResultOK ) {
						showCreateProgress();
						setProgress( "Collect", 100 );
						setProgress( "Create", 100 );
						showApplet();
						showButtons( true );
					}
					else {
						showError( res.errorMessage );
						isDownloaded = true;
						showButtons( false );
					}
				}
				else {
					setProgress( "Collect", res.progressCollect );
					
					if ( res.progressCreate != undefined && res.progressCreate > 0 ) {
						showCreateProgress();
						setProgress( "Create", res.progressCreate );
					}
					
					setTimeout( 'getProgressInfo()', 100 );
				}
			}
		);
	}

	function getAppletColors() {
		var app = document.getElementById( "theapplet" );
		var colors = getElemColors( app, null );

		var bgcolor = new RGBColor( colors[ 'bgcolor' ] );
		var fgcolor = new RGBColor( colors[ 'fgcolor' ] );

		return bgcolor.r + "," + bgcolor.g + "," + bgcolor.b + "|" + fgcolor.r + "," + fgcolor.g + "," + fgcolor.b;
	}


	function onDownloadComplete() {
		isDownloaded = true;
	}

	function leavePage() {
		if ( !checkUnload ) {
			return true;
		}
		if ( isDownloaded ) {
			$.post( "/cd/deldir.jsp?id=<%= id %>" );
		}
		return true ;
	}

//    $(window).bind('beforeunload', function() {
//        if ( checkUnload && !isDownloaded) {
//            return "<%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_ABORTED" )%>";
//        }
//    }); 
	
	
	function exit() {
<% if ( "iso".equals( ext ) ) { %>
		var text = "<%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_HAVE_NOT_DOWNLOAD_BURNED_ISO" ) %>";
<% }
	else { %>
		var text = "<%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_HAVE_NOT_DOWNLOAD_DICOM" ) %>";
<% } %>
		if ( isDownloaded || confirm( text ) ) {
			checkUnload = false;
			jump( 'deldir.jsp?id=<%= id %>&<%= backLink %>' );
		}
	}
   
</SCRIPT>
</HEAD>
<BODY onunload="return leavePage();" onload="getProgressInfo();">
<%
	TabToolbox.makeTabs( is, is.tabbean, "cases/index.jsp", "White");
%>

<TABLE border=1 width="100%" cellpadding=0 cellspacing=0 class=BgShadow>
  <TR><TD style="padding-top: 10; padding-bottom: 10;">
  <TABLE border=0 width="100%"><TR><TD>
   &nbsp;&nbsp;
   <FONT size=4>
   <%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_LAUNCH_CREATION_CONFORMANT_ISO" ) %>
   </FONT>
  </TD></TR></TABLE>
  </TD></TR><TR><TD>
   <%= studiesTable %>
   <center><b>
 	<%= LocalizedMessage.getCompoundMessage( "CD_BURNCD_TOTAL_SIZE", new Format[] { null }, new Object[] { parStSize }, true) %>
   </b></center>
  </TD></TR>
  <TR><TD style="height: 30px;" class=BgLight>
   <div id="progressErrorDiv" style="text-align: center; font-weight: bold; visibility: hidden; padding: 20px;" class="FontError">&nbsp;
   </div>
  </TD></TR>
  <TR id="progressTR"><TD>
  
<table border=0 width="100%" cellspacing=0 cellpadding=0 class=BgShadow style="padding-top: 10px; padding-bottom: 10px;">
 <tr><td align="center" width="50%">
  <div id="progressCollectDiv">
  <%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_GATHER_CONVERT" ) %>
  <%
	CDBurnToolbox.printProgressBar( out, "Collect" );
  %>
  </div>
  <div id="progressCreateDiv" style="visibility: hidden;">
  <%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_CREATE" ) %>
  <%
	CDBurnToolbox.printProgressBar( out, "Create" );
  %>
  </div>
 </td><td align=center width="50%">
  <div id="appletpanel" style="visibility: hidden;">
	<EMBED id="theapplet"
    type = "application/x-java-applet"
    RCODEBASE = "<%= is.httpx_host %>/applets"
    CODE = "ep.clients.FileDownloader"
    ARCHIVE = "<%= is.httpx_host %>/applets/epapplets.jar,<%=is.httpx_host + "/applets/jai_codec.jar"%>"
    WIDTH = "60%"
    HEIGHT = "50"
    NAME = "EP File Downloader"
    MAYSCRIPT = "true"
    mode = "<%= mode %>"
    filename = "<%= name %>"
    fileurl = "<%= Helper.htmlEncode( is.httpx_host + "/cd/getiso.cgi/cd" + id + "." + ext ) %>"
    stlabel = "<%= Helper.htmlEncode( label ) %>"
    donecallback = "onDownloadComplete"
    server = "<%= is.httpx_host %>"
    sessionid = "<%= is._sid %>"
    nodebug = "true">
   </EMBED>
  </div>
  </td>
 </tr>
 </table>
 </TD></TR>
 <tr id="buttonsPanel" align="right" style="visibility: collapse;"><td style="padding-top: 20px; padding-bottom: 5px;">
<%
	if ( IMAdminToolbox.bAdminRight( is ) && "iso".equals( ext ) )  {
		// Has ADMIN rights and an iso file was created - give an option to burn the iso file on server side
%>
  <span id="burnOnServer" style="visibility: hidden;" style="margin: 30px;">
  <A href="javascript:jump('isoburner.jsp?id=<%= id %>&<%= backLink %>');" onClick = "isDownloaded=true;checkUnload=false;">
  <%= JSHelper.getJsLocalizedButton( "BUTTON_BURN_ON_SERVER", "BUTTON_NULL", false ) %></A></span>
<%
	}
//	else {
//		out.println( "<SCRIPT language=\"JavaScript\">isDownloaded = true;</SCRIPT>" );
//	}
%>
  <span style="margin: 30px;">
 <A href="viewlog.jsp?id=<%=id%>" target=new><%= JSHelper.getJsLocalizedButton( "BUTTON_VIEW_LOG", "BUTTON_NULL" , false )%></A> 
 </span>
  <span style="margin: 30px;">
 <A href="viewlog.jsp?id=<%=id%>&cType=text" target=new><%= JSHelper.getJsLocalizedButton( "BUTTON_VIEW", "BUTTON_NULL", false )%></A> 
 </span>
  <span style="margin: 30px;">
 <A href="javascript:exit()"><%= JSHelper.getJsLocalizedButton("BUTTON_BACK_TO_LIST", "BUTTON_NULL", false ) %></A>
 </span>
</td></tr>
<TR><TD class=FieldBlock style="padding-top: 0; height: 18;"><font size=0>&nbsp;</font></td></TR>
</table>


<%-- SCRIPT language="JavaScript">getProgressInfo()</SCRIPT -- %>
</BODY>
</HTML>--%>