<%--
 * Component: dotcom
 *
 * Collects device information for dotcom configuration
 * Retrieves deviceid for a peer device (child or parent).
 *
 * This page is used by the peer to figure out self device id in existing dotcom systems.
 *
 * No Parameters:
 *
 * Last Updated     : $Author: rty $
 * Update Date Time : $Date: 2013/10/29 16:22:38 $
 * RCS File Name    : $RCSfile: getconfig.jsp,v $
 * RCS Revision     : $Revision: 1.5 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
	page import="imagemed.imsession.*, imagemed.jsputil.*, imagemed.dotcom.*, java.util.*, java.io.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%


	String devId = request.getParameter( "except" );
	boolean needSession = true;
	try {
		Properties devPrp = DotcomToolbox.checkIPAddress( request.getRemoteAddr(), null );

		if ( devPrp != null ) {
			needSession = false;
			devId = devPrp.getProperty( "ID" );
		}
	}
	catch ( Throwable th ) {
	}
	if (needSession) {
		Sessita sessita = Sessita.Create(request, response);
		Session sess = sessita.getSession();
	}

	Throwable collectException = null;
	DotcomConfig dcfg = new DotcomConfig();
	try {
		dcfg = DotcomConfig.reCollect( response.getWriter(), devId );	
	}
	catch ( Throwable th ) {
		collectException = th;
	}

	if ( !( devId != null || "true".equals( request.getParameter( "serialize" ) ) ) ) {
%><HTML><HEAD><TITLE>Dotcom Cfg</TITLE></HEAD><BODY><PRE>
<%
		if ( collectException != null ) {
			out.println( "Collect Exception: " + collectException.toString() );
			collectException.printStackTrace( new PrintWriter( out ) );
		}
		out.println( "collect returns: " + ( dcfg != null ) );
		out.println( "devId: " + devId );
		try {
			dcfg.print( out );
		}
		catch ( Throwable th ) {
			out.println( "Exception: " + th.toString() );
		}

		Vector<String> archiveDevices = dcfg.getArchiveServers();
		out.println( "Archive devices:" );
		if ( archiveDevices != null ) {
			for ( Iterator<String> i = archiveDevices.iterator(); i.hasNext(); ) {
				out.println( "     " + i.next() );
			}
		}


		DotcomDevice selfDevice = dcfg.getSelfDevice();
		if ( null != selfDevice ) {
			out.println( "---------------\n" );
			out.println( selfDevice.getDebug() );
			out.println( "</pre></body></html>" );
		}

%></PRE></BODY></HTML><%
	}
%>
