<%--
 * Component: imadmin
 *
 * Description:
 *   Customize pages and logos
 *
 * Parameters:
 *   op      : Upload/Confirm
 *   banner,logo : uploading files
 *
 * $Author: pzahorcsek $
 * $Date: 2014/04/23 14:37:20 $
 *
 *  RCS File Name    : $RCSfile: logos.jsp,v $
 *  RCS Revision     : $Revision: 1.6 $
 *  Locked by        : $Locker:  $
 *  Symbolic name    : $Name:  $
 *  State            : $State: Exp $
--%><%@page import="com.erad.pacs.modules.gwt.session.BrowserInfo"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@page import="com.erad.pacs.common.interfaces.action.Action"%>
<%@page import="com.erad.pacs.app.broker.table.internals.ActionImpl"%>
<%@
  page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,imagemed.exception.*,
  java.io.*,imagemed.http.tabs.*"
  
%><%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession( );
	
  response.setHeader("Pragma" , "no-cache");
  response.setHeader("Cache-Control" , "no-cache, must-revalidate");
  response.setHeader("Expiry-Date" , "Friday, 31-Dec-70 23:59:59 GMT");

  if (!sess.getRights(  ).hasAdminRight(  )) { //Has no ADMIN RIGHT?%>
    <BR>
    <CENTER><H3>
      <%= LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) %>
    </H3></CENTER></BODY></HTML>
<%
    return;
  }

	Syslog slog = new Syslog( "logos", 0 , IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );

%><%-- -----FUNCTION---- --%><%!
  boolean changeFileIfUploaded( String sourceFileName, String targetFileName )
  {
    if ( sourceFileName==null )   return false;
    String content = Helper.readTextFile( sourceFileName );
    if ( content==null || "".equals(content) )   return false;

    File tmp = new File(sourceFileName);
    File target = new File(targetFileName);
    Helper.renameToNotThrowsException( tmp, target );
    return true;          //  Changed
  }
%><%-- -----INIT & PROCESS---- --%><%

  String thisPage = "/imadmin/logos.jsp";
  MultipartParser req = new MultipartParser( request, IMEnvBase.getEnv("TMP") );
  String EnvMainData  = IMEnvBase.getEnv("MAIN_DATA") + "/";
  boolean needFresh = false;
  String opValue = req.getParameter("op");
  if ( "Upload".equals(opValue) || "Confirm".equals(opValue) ) { //  has got modifier request
    boolean bannerUploaded = changeFileIfUploaded( req.getParameter("banner"), EnvMainData+"MessageCenterWhite"+IMEnv.getCompTypePrefix()+".gif" );
    needFresh |= bannerUploaded;
    if( bannerUploaded ) {
   		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "serverlogos" );
   		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
   		logEntry.setField( OperLogEntry.FIELD.MESSAGE, sess.getUser().getUserId() + " uploaded a new banner." );
   		// we don't know the original filename here
   		logEntry.log( sess, slog, Syslog.LOG_INFO );
    }
    boolean logoUploaded = changeFileIfUploaded( req.getParameter("logo"), EnvMainData+"WhiteLogo"+IMEnv.getCompTypePrefix()+".gif" );
    needFresh |= logoUploaded;
    if( logoUploaded ) {
   		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "serverlogos" );
   		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
   		logEntry.setField( OperLogEntry.FIELD.MESSAGE, sess.getUser().getUserId() + " uploaded a new logo." );
   		// we don't know the original filename here
   		logEntry.log( sess, slog, Syslog.LOG_INFO );
    }
  }
%><%-- -----HTML---- --%><HTML>

<HEAD><TITLE><%= sess.getHttpServer( ) + " - " + LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_HTMLPAGE_TITLE" ) %></TITLE>
<%
  TabToolbox.writeIMpopup(out);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(response.getWriter(  ));
%>
</HEAD>
<BODY>
<%
//  TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicomsrv.jsp", "White");
  if (needFresh) {
%>
  <CENTER>
    <BR>
    <FONT SIZE=4>
    <span class=FontErrorLight>
		<%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_UPLOAD_SUCCESS" ) %>
    </span>  
    </FONT>
  </CENTER>
<%
	}
  if ("Change".equals(request.getParameter("skin_op"))) {
  	String skinName = request.getParameter("skinName");
  	StyleToolbox.setSkinName(sess, skinName );
  	out.println(Action.SCRIPT_HEAD+"document.location.href=\"/imadmin/logos.jsp\";"+Action.SCRIPT_TAIL);
  	
 		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "serverskin" );
 		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
 		logEntry.setField( OperLogEntry.FIELD.MESSAGE, sess.getUser().getUserId() + " changed the skin to " + 
 			( skinName == null || "".equals( skinName ) ? "built in default" : skinName ) );
 		logEntry.log( sess, slog, Syslog.LOG_INFO );

  	return;
  }
%>  
<table width="100%" border=1 cellpadding=0 cellspacing=0 class=BgShadow>
	<tr>
		<td colspan=2>
			<br>
			&nbsp;&nbsp;<font size="4"><%= LocalizedMessage.getSimpleMessage ( "IMADMIN_LOGOS_TITLE" ) %></font>
			<br> &nbsp;
		</td>
	</tr>
</table>
  
  <% 
  String[] customSkins = StyleToolbox.getAllSkins();
  if (customSkins.length > 0) {
  	String currentSkin = StyleToolbox.getSkinName();
  %>
  			<center>&nbsp;<h3><%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_WEB_PAGE_STYLE" ) %></h3>
<form method="post">

<table cellpadding="2" class=BgShadow>
<tbody><tr class="BgMedLight">
<td><%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_SKIN_NAME" ) %></td>
<td>
<select name="skinName">
<option value=""><%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_BUILT_DEFAULT" ) %></option>
<%
	for ( String skin : customSkins ) {
		out.println("<option value=\""+skin+"\""+(skin.equals(currentSkin)?" selected":"")+">"+skin+"</option>");
	}

%>
</select>
</td>
</tr>
<tr class="BgMedLight">
<td>&nbsp;</td><td>
<%= JSHelper.getJsInputLocalizedButton( new BrowserInfo(  ), "BUTTON_CHANGE", "skin_op", "Change" ) %>
</td>
</tr>

</tbody></table>
</form></center>
    <HR>
<%}%>
  
  <CENTER>
  <FORM ENCTYPE=MULTIPART/FORM-DATA METHOD=POST>
    <BR>
    <H2><%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_BANNER" )%></H2>
    <TABLE class=BgLight width=530 border=1>
      <TR><TD height=80 align="center">
        <IMG width=500 height=50 src="<%=TabBean.getImageURL("MessageCenterWhite") %>">
      </TD></TR>
    </TABLE>
    <%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_UPLOAD_NEW" )%><INPUT type="file" name="banner">
    <HR>

    <BR>
    <H2><%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_LOGO" )%></H2>
    <TABLE class=BgLight width=90 border=1>
      <TR><TD height=90 align="center">
        <IMG width=60 height=60 src="<%=TabBean.getImageURL("WhiteLogo") %>">
      </TD></TR>
    </TABLE>
    <%= LocalizedMessage.getSimpleMessage( "IMADMIN_LOGOS_UPLOAD_NEW" )%><INPUT type="file" name="logo">
    <HR>

    <BR><BR>
    <%= JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_UPLOAD", "op", "Upload" ) %>
    <a onclick="top.parent.evoNavigate('settings:')"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></a>
<%--    <INPUT TYPE="SUBMIT" NAME="op" VALUE="Upload">--%>
  </FORM>
  </CENTER>

</BODY>
</HTML>
