<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="imagemed.util.Helper"
%><%@page import="com.erad.pacs.app.broker.table.internals.TableImpl"%><%@page import="imagemed.exception.IMGeneralException"
%><%@page import="java.util.Random"
%><%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" 
%><%@taglib uri="http://pacs.erad.com/eptags" prefix="ep" 
%><%@page isErrorPage="true" %><%Helper.defaultCatch( exception );%>
<html>
	<head>
		<title>..Computer says no!</title>
		<%
  			TableImpl.printCommonScript( response.getWriter() );
		%>
		<style>
			pre {
    			margin: 0;
			}
		</style>
	</head>
	<body style="background-image: url(/art/img/broken<%= new Random().nextBoolean() ? "_heart" : "" %>.svg); background-attachment: fixed; background-repeat: no-repeat; background-position: bottom right; background-size: contain; background-color: #702; color: #eee; padding: 10px; padding-left: 30px;">
<%
	if (exception instanceof SessionException) {
%>
	<h1>Your session has expired.</h1>
	<script>
	try {
		top.parent.evoNavigate("login:");
	}
	catch (e) {
		console.log(e);
		document.write("<p>Please login again.</p>");
	}
	</script>
<%
	} else if (exception instanceof IMGeneralException) {
%>
	<script>
		document.body.style.background="";
		document.title="<%= ((IMGeneralException) exception).getHtmlTitle() %>";
	</script>
	<h1><%= ((IMGeneralException)exception).getHtmlMessage() %></h1>	
<%
	} else {
%>
		<h1>He's Dead, Jim!</h1>
		<ul>
			<li><b>status code:</b> ${pageContext.errorData.statusCode}</li>
			<li><b>servlet:</b> ${pageContext.errorData.servletName}</li> 
			<li><b>request:</b> ${pageContext.errorData.requestURI}</li>
			<li><b>exception:</b><br/>
				<ep:display-exception throwable="${pageContext.errorData.throwable}"/>
			</li>
			<li><b>parameters:</b><br/>
				<ul>
					<c:forEach var="par" items="${paramValues}">
						<li><b>${par.key}:</b> ${par.value[0]}</li>
					</c:forEach>
				</ul>
			</li>
			<li><b>cookies:</b><br/>
				<ul>
					<c:forEach var="c" items="${cookie}">
						<li><b>${c.key}:</b><br/>
							<ul>
								<li><b>value:</b> ${c.value.value}</li>
								<li><b>comment:</b> ${c.value.comment}</li>
								<li><b>domain:</b> ${c.value.domain}</li>
								<li><b>max age:</b> ${c.value.maxAge}</li>
								<li><b>path:</b> ${c.value.path}</li>
								<li><b>secure:</b> ${c.value.secure}</li>
							</ul>
						</li>
					</c:forEach>
				</ul>
			</li>
		</ul>
<%
	}
%>
	</body>
</html>