#!/bin/sh

. $HOME/etc/setenv.sh

# set classpath for java
CLASSPATH=$CLASSPATH:$HOME/component
export CLASSPATH

cd $HOME/component
classFileConvertDatabase="cases/ConvertDatabase.class"
classFileTableIndexAndColums="cases/TableIndexAndColums.class"
classFileTableIndexes="cases/TableIndexes.class"

if [ -f "$classFileConvertDatabase" ] && [ -f "$classFileTableIndexAndColums" ] && [ -f "$classFileTableIndexes" ]; then
	echo $JAVA_HOME/bin/java ${CASES_HOME#$HOME/component/}.ConvertDatabase "$@"
	$JAVA_HOME/bin/java ${CASES_HOME#$HOME/component/}.ConvertDatabase "$@"
else
	echo "One or more required classfiles are missing."
fi
