#!/bin/sh

# This script generates stastics file for a COLID in Dcstudy table
#
#  usage: createStringStat.sh <COLID>
#

if [ -z "$1" ] ; then
	echo "usage: createStringStat.sh <COLID>"
	exit 1
fi

COLID=$1

DBN=`sql.sh "select DBNAME from Dcfields where COLID='$COLID'"|tail -n 1`

. $HOME/etc/setenv.sh

$JAVA_HOME/bin/java imagemed.imtables.queryqualifier.evaluator.StringStatBuilder -t "Dcstudy" -cv "$COLID" -c "$DBN" -o "$CONF"
