<%--
 * Component: cases
 *
 * Description:
 *   Showing an image in an iframe in attachments.jsp
 *
 * Parameters:
 *   imgName : [R] URL of the image
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.toolbox.MahagoniToolbox"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,
		java.sql.*,java.io.*,java.util.*,imagemed.types.*, imagemed.types.string.*, imagemed.dicom.*,
		imagemed.dotcom.DotcomConfig"

%>
<%@page import="com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl" %>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- Input Parameters --%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();
%>
<head>
	<STYLE type="text/css">
		img.full {
			cursor:url(/cases/art/zoommin2.cur), pointer;
		}
	</style>
	
<script language='javascript'>
	function changeZoom() {
		if (parent.imageClass == "width") {
			parent.imageClass = "full";
		}
		else if (parent.imageClass == "full") {
			parent.imageClass = "fit";
		}
		else if (parent.imageClass == "fit") {
			parent.imageClass = "width";
		}
		document.getElementById("imgTag").className = parent.imageClass; 
	};

	function dumpObj( obj, skipEmpty ) {
		var dump = "";
		for ( var i in obj ) {
			try {
			if ( typeof obj[ i ] == 'function' ) {
				continue;
			}
			if ( !skipEmpty || obj[ i ] ) {
				dump += "\n" + i;
				dump += " -> " + obj[ i ];
			}
			}
			catch (e){}
		}
		return dump;
	};

	function addCSSRule(className, rule) {
		var oSheet = document.styleSheets[0];
		if( oSheet.insertRule ) {
		  oSheet.insertRule(className+'{'+rule+'}', oSheet.cssRules.length); // 'body { background: #779; }'
		} 
		else if( oSheet.addRule ) {
		  oSheet.addRule(className, rule); // 'body','background: #779;'
		}
		else {
			alert("Unsupported browser, dynamic CSS creation failed).");
		}
	};
	
	function init2() {
		if (img.height == 0) {
			setTimeout(init2, 100);
			return;		
		}
		var imgHeight = img.height;
		var imgWidth = img.width;
		// generate CSS
		var winHeight = parent.document.getElementById("<%=MahagoniToolbox.getValue( request.getParameterMap(), "iframeTD", "iframeTD")%>").clientHeight-20;
		var winWidth = parent.document.getElementById("<%=MahagoniToolbox.getValue( request.getParameterMap(), "iframeTD", "iframeTD")%>").clientWidth-20;
		var wfRule = imgWidth>winWidth?"width: "+winWidth+"px;height: auto;":"";
		var hfRule = imgHeight>winHeight?"height: "+winHeight+"px;width: auto;":"";
		// see which rule is stronger
		var strongRule = hfRule;  
		var weakRule = wfRule
		addCSSRule("img.width", "cursor:url(/cases/art/zoompls2.cur), pointer;"+weakRule);
		addCSSRule("img.fit", "cursor:url(/cases/art/zoomdyn.cur), pointer;"+strongRule);
		// check whether the width or height of the image should be fit fot fit-to-page
		//alert("winHeight: "+winHeight+", winWidth: "+winWidth+", imgHeight: "+imgHeight+", imgWidth: "+imgWidth);

		// add image to document
		if (typeof parent.imageClass == "undefined") {
			parent.imageClass = "fit";
		}
		img.className = parent.imageClass;
		document.body.removeChild(msgDiv);
		document.body.appendChild(img);
	}
	
	var img;
	var msgDiv;
	var initcount=0;
		
	function init() {
		// display "Loading..." message
		msgDiv = document.createElement("div");
		msgDiv.innerHTML = "<h1><%=LocalizedMessage.getSimpleMessage( "LOADING_MSG" )%></h1>";
		document.body.appendChild(msgDiv);
		// generate image
		img = new Image();
		img.id = 'imgTag';
		img.onclick = changeZoom;
		img.src = '<%=request.getParameter("imgName")%>';
		init2();
	};
</script>	
</head>
<body onLoad="init();">
</body>