<%--
 * Component: cases
 *
 * Description:
 *      Packs 'herelt' DICOM files and thumbnails of a study and print it to the output.
 *      If requested the data will be printed using LZS or DEFLATE compressioni.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.common.interfaces.list.ListDescriptor"%>
<%@page import="com.erad.pacs.common.libs.RequestInfo"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@ page trimDirectiveWhitespaces="true" %>
<%@
	page import="java.util.*, java.io.*, imagemed.dcprocessing.Herpa, imagemed.util.*, com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.imsession.*, imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%Syslog logger = new Syslog( "herpa", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	logger.syslog( Syslog.LOG_DEBUG, "Starting herpa" );

	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession(  );

	// FIXME: dotcom
	/*is.bCheckHttpsAndRedirect = false;
	if ( ProxyToolbox.init( is, null, logger ) ) {
		// Session parameters were proxied from parent child, regID must be set. 
		if ( is.regID == null ) {
			logger.syslog( Syslog.LOG_ERR, "No user ID was received from parent/child");
			return;
		}
	}
	else {
		// Check regular user session
		if (!is.regOK()) {
			return;
		}
	}*/

	logger.syslog( Syslog.LOG_DEBUG, "Start executing  herpa" );

	String parStudy = request.getParameter( "f" );
	String parKey = request.getParameter( "cKey" );
	
	String redirHost = RedirectToolbox.getClosestRedirectHostForStudy( sess, parStudy );
	if ( redirHost != null ) {
		String redirURL = RedirectToolbox.getClosestRedirectForStudy( sess, parStudy ) + "/cases/herpa.jsp?" + request.getQueryString();
		response.sendRedirect( redirURL );
		return;
	}
	response.addHeader( "Local", "" + LocalIp.isLocal( sess.getClientAddress().getHostAddress() ) );
	
	boolean bTranscribeOnly = "true".equals(request.getParameter("cTranscribe"));
	boolean bEditReportOnly = "true".equals(request.getParameter("cEditReport"));

	{
///////Creating the WorklistResult, ////////////////////////////////////////
///////the list which the user reads the studies from //////////////////////

		TableDescriptorImpl desc = new TableDescriptorImpl();

		String SQLtables[] = { "Dcstudy", "Dcobject" };
		FieldManagerImpl fm = new IMSQLFieldManagerImpl("Dcfields", "Dctypes", SQLtables);
		desc.setFieldManager(fm);

		boolean isAdmin = sess.getRights().hasAdminRight(  );
		WorklistTableParamsImpl tparams = new WorklistTableParamsImpl( new ListDescriptorImpl(), sess );
		desc.setTableParams( tparams );

		WorklistResultImpl wr = new WorklistResultImpl( desc, sess, true, true );

////////////////////////////////////////////////////////////////////////////

		logger.syslog(Syslog.LOG_DEBUG,"Done worklist table");

		String errMessage = Check.checkRights( sess, bTranscribeOnly, bEditReportOnly );
		if ( errMessage == null ) {
			if ( parStudy == null ) {
				errMessage = "";
			}
			else {
				Check ch = new Check( parStudy, parKey );
				errMessage = ch.hasAccess( sess, wr, false );
			}
		}

		if ( errMessage != null ) {
			response.setHeader( "IMAuthentication", errMessage );
			out.println( errMessage );
			return;
		}
	}

	boolean bCompr = "true".equals( request.getParameter( "bCompr" ) );
	if ( "true".equals( request.getParameter( "bAuto" ) ) ) {
		bCompr = !LocalIp.isLocal( sess.getClientAddress().getHostAddress() );
	}
	response.addHeader( "X-compr", "" + bCompr );
	boolean bThumb = "true".equals( request.getParameter( "bThumb" ) );
	int nPartMode = 0;
	String sPartMode = request.getParameter( "nPartMode" );
	if( sPartMode != null ) {
		try {
			nPartMode = Integer.parseInt(sPartMode);

		}
		catch(Throwable t) {
			nPartMode =0;
		}
	}
	boolean bEncThName = "true".equals( request.getParameter( "bEncThName" ) );

	if ( parStudy == null ) {
		response.setContentType( "text/html" );
		logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
		response.setHeader( "IMAuthentication", "nostudy" );
		return;
	}

	if ( ProxyToolbox.checkAndProxy( sess, parStudy, true) ) {
		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
		return;
	}

	logger.syslog( Syslog.LOG_DEBUG, "Create Response" );

	response.setContentType( "text/html" );

	try {
		Herpa herpa = new Herpa( parStudy, null, bThumb );

		herpa.setPartMode( nPartMode );
		herpa.SetEncodeThumbNames( bEncThName );

		String vv = request.getHeader( "ViewerVersion" );
		logger.syslog( Syslog.LOG_DEBUG, "Viewer version: " + vv ); 

		herpa.setViewerVersion( vv );
		
		herpa.writeTo( response.getOutputStream(), bCompr ); 
	}
	catch ( Throwable t ) {
		logger.syslog( Syslog.LOG_DEBUG, "ERROR3:" + t.toString() ); 
		out.print( t.toString() );
	}

	if ( true ) {
		return;
	}%>