function checkPOD( fid ) {
	form = document.forms[ 0 ];
	var startHH = form.elements[ "f" + fid + "podShh" ];
	var startMM = form.elements[ "f" + fid + "podSmm" ];
	var endHH = form.elements[ "f" + fid + "podEhh" ];
	var endMM = form.elements[ "f" + fid + "podEmm" ];
	var startMMValue = new Number( startMM.value );
	var isOK = true;
	if ( isNaN( startMMValue ) || startMMValue > 59 || startMMValue < 0 ) {
		if ( startMM.value ) {
			if ( startMM.value.length > 0 ) {
				isOK = false;
			}
		}
		startMM.value = "0";
		startMMValue = new Number( 0 );
	}
	var startHHValue = new Number( startHH.value );
	if ( isNaN( startHHValue ) || startHHValue > 24 || ( startHHValue.valueOf() == 24 && startMMValue > 0 ) || startHHValue < 0 ) {
		if ( startHH.value ) {
			if ( startHH.value.length > 0 ) {
				isOK = false;
			}
		}
		startHH.value = "0";
		startHHValue = new Number( 0 );
	}
	var endMMValue = new Number( endMM.value );
	if ( isNaN( endMMValue ) || endMMValue > 59 || endMMValue < 0 ) {
		if ( endMM.value ) {
			if ( endMM.value.length > 0 ) {
				isOK = false;
			}
		}
		endMM.value = "0";
		endMMValue = new Number( 0 );
	}
	var endHHValue = new Number( endHH.value );
	if ( isNaN( endHHValue ) || endHHValue > 24 || ( endHHValue.valueOf() == 24 && endMMValue > 0 ) || endHHValue < 0 ) {
		if ( endHH.value ) {
			if ( endHH.value.length > 0 ) {
				isOK = false;
			}
		}
		if ( endMMValue > 0 ) {
			endHH.value = "23";
			endHHValue = new Number( 23 );
		}
		else {
			endHH.value = "24";
			endHHValue = new Number( 24 );
		}
	}
	if ( !isOK ) {
		alert( "Invalid value(s) found, replaced with default value!" );
	}
	if ( startHH.value.length > 0 && endHH.value.length > 0 && ( startHHValue > endHHValue || ( startHHValue.valueOf() == endHHValue.valueOf() && startMMValue > endMMValue && startMM.value.length > 0 && endMM.value.length > 0 ) ) ) {
		var tmp = endHH.value;
		endHH.value = startHH.value;
		startHH.value = tmp;
		tmp = endMM.value;
		endMM.value = startMM.value;
		startMM.value = tmp;
		alert( "Invalid time-period detected, bounds inverted!" );
	}
};

function checkTime( fname, defHour, defMin ) {
	form = document.forms[ 0 ];
	var startHH = form.elements[ fname + "hh" ];
	var startMM = form.elements[ fname + "mm" ];
	var startMMValue = new Number( startMM.value );
	var isOK = true;
	if ( isNaN( startMMValue ) || startMMValue > 59 || startMMValue < 0 ) {
		if ( startMM.value ) {
			if ( startMM.value.length > 0 ) {
				isOK = false;
			}
		}
		startMM.value = defMin;
		startMMValue = new Number( defMin );
	}
	var startHHValue = new Number( startHH.value );
	if ( isNaN( startHHValue ) || startHHValue > 24 || ( startHHValue.valueOf() == 24 && startMMValue > 0 ) || startHHValue < 0 ) {
		if ( startHH.value ) {
			if ( startHH.value.length > 0 ) {
				isOK = false;
			}
		}
		startHH.value = defHour;
		startHHValue = new Number( defHour );
	}
	if ( !isOK ) {
		alert( "Invalid value(s) found, replaced with default value!" );
	}
};

function CheckboxHandler( type, colid, mode ) {
	// type can be "src" or "sel" right now
	// filter modes are:
	// 0 -> strict (is)
	// 1 -> startswith
	// 2 -> like (contains)
	// 3 -> strict (is) not
	// 4 -> startswith not
	// 5 -> like (contains) not
	this.type = type;
	this.mode = mode;
	this.imgBase = "";
	switch (mode) {
	case 0:
		this.imgBase = "is";
		break;
	case 1:
		this.imgBase = "begins";
		break;
	case 2:
		this.imgBase = "contains";
		break;
	case 3:
		this.imgBase = "isnot";
		break;
	case 4:
		this.imgBase = "beginsnot";
		break;
	case 5:
		this.imgBase = "containsnot";
	}

	this.hidden = document.getElementById( "f" + colid + type + "CB_" + mode );
	this.image = document.getElementById( "f" + colid + type + "CB_" + mode + "_img" );

	this.isChecked = function() {
		return this.hidden.name != "";
	};

	this.setChecked = function( pushed ) {
		this.hidden.name = pushed ? this.hidden.id : "";
		this.image.src = "/art/b/" + this.imgBase + ( pushed ? ".p" : "" ) + suffix + ".png";
		// suffix comes from TableScripts.js and is "" or ".big" depending on screen resolution
	};

	this.init = function( pushed, title ) {
		this.setChecked( pushed );
		if ( mul > 1 ) {
			// high resolution, replace title of link with popup DIV
			delete this.image.title;
			var hoverDiv = document.createElement( "div" );
			hoverDiv.innerHTML = title;
			hoverDiv.className = "filterCBtitle";
			hoverDiv.style.left = "50px";
			hoverDiv.style.top = this.image.parentNode.style.height;// ""25px;

			this.image.parentNode.appendChild( hoverDiv );
		}
		else {
			this.image.title = title;
		}
	};
};

function filterCbHandler( fieldName, defaultSearchMode ) {
	this.m_fieldName = fieldName;
	this.m_defaultSearchMode = defaultSearchMode;

	this.m_srcCheckboxes = null;

	this.getSrcCheckbox = function( mode ) {
		var res = new CheckboxHandler( "src", this.m_fieldName, mode );
		return res.image ? res : false;
	};

	this.getSrcCheckboxes = function() {
		if ( !this.m_srcCheckboxes ) {
			this.m_srcCheckboxes = new Array();
			// search filter modes are:
			// 0 -> strict (is)
			// 1 -> startswith
			// 2 -> like (contains)
			// 3 -> strict (is) not
			// 4 -> startswith not
			// 5 -> like (contains) not
			for (var i = 0; i < 6; i++) {
				var cb = this.getSrcCheckbox( i );
				if ( cb ) {
					this.m_srcCheckboxes.push( cb );
				}
			}
		}
		return this.m_srcCheckboxes;
	};

	this.m_selCheckboxes = null;

	this.getSelCheckboxes = function() {
		if ( !this.m_selCheckboxes ) {
			this.m_selCheckboxes = new Array();
			// select can have two checkboxes: is and isnot
			var cb = new CheckboxHandler( "sel", this.m_fieldName, 0 );// document.getElementById( "f" + this.m_fieldName + "selCB" );
			if ( cb.image ) {
				this.m_selCheckboxes.push( cb );
			}
			cb = new CheckboxHandler( "sel", this.m_fieldName, 3 );// document.getElementById( "f" + this.m_fieldName + "selNOT" );
			if ( cb.image ) {
				this.m_selCheckboxes.push( cb );
			}
		}
		return this.m_selCheckboxes;
	};

	this.getCheckboxes = function( isSearch ) {
		return isSearch ? this.getSrcCheckboxes() : this.getSelCheckboxes();
	};

	this.activated = function( isSearch ) {
		// see if a suitable CB is on, and toggle the default if not.
		var goodCBs = this.getCheckboxes( isSearch );
		for (var i = 0; i < goodCBs.length; i++) {
			if ( goodCBs[ i ].isChecked() )
				return;
		}
		var badCBs = this.getCheckboxes( isSearch ? false : true );
		for (var i = 0; i < badCBs.length; i++) {
			badCBs[ i ].setChecked( false );
		}
		if ( isSearch ) {
			var defCB = this.getSrcCheckbox( this.m_defaultSearchMode );
			if ( defCB ) {
				defCB.setChecked( true );
				return;
			}
		}
		goodCBs[ 0 ].setChecked( true );
	};

	this.toggle = function( type, mode ) {
		for (var j = 0; j < 2; j++) {
			var cbs = this.getCheckboxes( j == 0 );
			for (var i = 0; i < cbs.length; i++) {
				if ( cbs[ i ].type == type && cbs[ i ].mode == mode ) {
					cbs[ i ].setChecked( !cbs[ i ].isChecked() );
				}
				else {
					cbs[ i ].setChecked( false );
				}
			}
		}
	};
};

var filterCBHandlers = new Array();

function registerFilterCBHandler( fieldName, defaultSearchMode ) {
	filterCBHandlers[ fieldName ] = new filterCbHandler( fieldName, defaultSearchMode );
};

function activatedFilter( fieldName, isSearch ) {
	filterCBHandlers[ fieldName ].activated( isSearch );
};

function toggleFilter( type, colid, mode ) {
	filterCBHandlers[ colid ].toggle( type, mode );
};

function handleCBKeyPress( event, type, colid, mode ) {
	if ( event ) {
		var unicode = event.charCode ? event.charCode : event.keyCode;
		if ( unicode && unicode == 32 ) {
			toggleFilter( type, colid, mode );
		}
	}
	return true;
};

var allDTCBSuffixes = [ "datAFTERcb", "datNEWERcb", "datFURTHERcb", "datBEFOREcb", "datOLDERcb", "datCLOSERcb" ];
var compatibleCBSuffixes = new Array();
compatibleCBSuffixes[ "datAFTERcb" ] = [ "datBEFOREcb" ];
compatibleCBSuffixes[ "datBEFOREcb" ] = [ "datAFTERcb" ];
compatibleCBSuffixes[ "datNEWERcb" ] = [ "datOLDERcb", "datCLOSERcb" ];
compatibleCBSuffixes[ "datFURTHERcb" ] = [ "datCLOSERcb" ];
compatibleCBSuffixes[ "datOLDERcb" ] = [ "datNEWERcb" ];
compatibleCBSuffixes[ "datCLOSERcb" ] = [ "datFURTHERcb", "datNEWERcb" ];

var allDTInputSuffixes = [ "datOLDER", "datOLDERunit", "datNEWER", "datNEWERunit" ];

var dtCbImplications = new Array();
dtCbImplications[ "datOLDER" ] = [ "datOLDERcb", "datCLOSERcb" ];
dtCbImplications[ "datOLDERunit" ] = [ "datOLDERcb", "datCLOSERcb" ];
dtCbImplications[ "datNEWER" ] = [ "datNEWERcb", "datFURTHERcb" ];
dtCbImplications[ "datNEWERunit" ] = [ "datNEWERcb", "datFURTHERcb" ];
dtCbImplications[ "datAFTERbox" ] = [ "datAFTERcb" ];
dtCbImplications[ "datBEFOREbox" ] = [ "datBEFOREcb" ];

function relativeToAbsDate( rel, fdow, upper ) {
	var p = rel.indexOf( ' ' );
	var relUnit = rel.substr( p + 1 );
	var relVal = rel.substr( 0, p );
	var relMod = -1;
	if ( relVal.startsWith( '+' ) ) {
		relMod = 1;
		relVal = relVal.substr( 1 );
	}
	var res = new Date();
	// "minutes", "hours", "days", "weeks", "months", "years", "CW", "CM", "CQ", "CY"
	if ( relUnit == 'minutes' || relUnit == 'hours' || relUnit == 'days' || relUnit == 'weeks' ) {
		var quantum = 60000; // minute
		if ( relUnit != 'minutes' ) {
			quantum *= 60; // hour
			if ( relUnit != 'hours' ) {
				quantum *= 24; // day
				if ( relUnit != 'days' ) {
					quantum *= 7; // week
				}
			}
		}
		res.setTime( res.getTime() + relVal * relMod * quantum );
		return res;
	}
	if ( relUnit == 'months' ) {
		res.setMonth( res.getMonth() + relVal * relMod );
		return res;
	}
	if ( relUnit == 'years' ) {
		res.setFullYear( res.getFullYear() + relVal * relMod );
		return res;
	}
	// calendar week/month/quarter/year follows
	if ( relUnit == 'CW' ) {
		// first reset to the first day of current week and then shift
		var curdow = ( res.getDay() - fdow ) % 7;
		res.setDate( res.getDate() - curdow + relVal * relMod * 7 );
	}
	if ( relUnit == 'CM' ) {
		res.setDate( 1 ); // first day of current month
		res.setMonth( res.getMonth() + relVal * relMod );
	}
	if ( relUnit == 'CQ' ) {
		res.setDate( 1 ); // first day of current month
		res.setMonth( res.getMonth() - ( res.getMonth() % 3 ) ); // start fo current quarter
		res.setMonth( res.getMonth() + relVal * relMod * 3 );
	}
	if ( relUnit == 'CY' ) {
		res.setDate( 1 ); // first day of current month
		res.setMonth( 0 ); // first day of the year
		res.setFullYear( res.getFullYear() + relVal * relMod );
	}
	// calendar based ranges do not include their upper end (current week does not include first day of next week), so upper limits should be decreased by one day
	if ( upper ) {
		res.setDate( res.getDate() - 1 );
	}
	return res;
};

// handler of date/time filter comes here
function DTFilterHandler( fieldName, dateDispFormat, firstDayOfWeek ) {
	this.m_fieldName = fieldName;
	this.m_firstDayOfWeek = firstDayOfWeek;
	for (var i = 0; i < allDTCBSuffixes.length; i++) {
		$( "#" + fieldName + allDTCBSuffixes[ i ] ).change( {
			fn : fieldName,
			id : fieldName + allDTCBSuffixes[ i ]
		}, function( e ) {
			dtfElementNudged( e.data.fn, e.data.id );
		} );
	}
	for (var i = 0; i < allDTInputSuffixes.length; i++) {
		$( "#" + fieldName + allDTInputSuffixes[ i ] ).focus( {
			fn : fieldName,
			id : fieldName + allDTInputSuffixes[ i ]
		}, function( e ) {
			dtfElementNudged( e.data.fn, e.data.id );
		} );
		$( "#" + fieldName + allDTInputSuffixes[ i ] ).change( {
			fn : fieldName,
			id : fieldName + allDTInputSuffixes[ i ]
		}, function( e ) {
			dtfElementNudged( e.data.fn, e.data.id );
		} );
	}

	// init date pickers
	var dateAfter = $( "#" + fieldName + "datAFTER" ).val();
	var dateBefore = $( "#" + fieldName + "datBEFORE" ).val();
	this.m_dateBoxAfter = $( "#" + fieldName + "datAFTERbox" );
	this.m_dateBoxAfter.datepicker( {
		altField : "#" + fieldName + "datAFTER",
		altFormat : "yymmdd",
		dateFormat : dateDispFormat,
		changeYear : true,
		yearRange : "-100:+5",
		beforeShow : function( input, inst ) {
			var cal = inst.dpDiv;
			var offset = $( this ).offset();
			offset.top += $( this ).outerHeight();
			offset.left += $(this).outerWidth()-cal.outerWidth();
			setTimeout( function() {
				cal.offset(offset);
				if ( cal.position().top + cal.height() > jQuery( window ).scrollTop() + ( window.innerHeight || document.documentElement.clientHeight ) ) {
					cal.get( 0 ).scrollIntoView();
				}
			}, 10 );
		},
		firstDay : firstDayOfWeek
	} );
	this.m_dateBoxAfter.focus( {
		fn : fieldName,
		id : fieldName + "datAFTERbox"
	}, function( e ) {
		dtfElementNudged( e.data.fn, e.data.id );
	} );

	this.m_dateBoxBefore = $( "#" + fieldName + "datBEFOREbox" );
	this.m_dateBoxBefore.datepicker( {
		altField : "#" + fieldName + "datBEFORE",
		altFormat : "yymmdd",
		dateFormat : dateDispFormat,
		changeYear : true,
		yearRange : "-100:+5",
		beforeShow : function( input, inst ) {
			var cal = inst.dpDiv;
			var offset = $( this ).offset();
			offset.top += $( this ).outerHeight();
			offset.left += $(this).outerWidth()-cal.outerWidth();
			setTimeout( function() {
				cal.offset(offset);
				if ( cal.position().top + cal.height() > jQuery( window ).scrollTop() + ( window.innerHeight || document.documentElement.clientHeight ) ) {
					cal.get( 0 ).scrollIntoView();
				}
			}, 10 );
		},
		firstDay : firstDayOfWeek
	} );
	this.m_dateBoxBefore.focus( {
		fn : fieldName,
		id : fieldName + "datBEFOREbox"
	}, function( e ) {
		dtfElementNudged( e.data.fn, e.data.id );
	} );

	var preDefRngSelect = $( "#" + fieldName + "datRngSel" );
	preDefRngSelect.change( {
		fn : fieldName,
		id : fieldName + "datRngSel"
	}, function( e ) {
		dtfElementNudged( e.data.fn, e.data.id );
	} );

	// <input
	$( "<input type=text id='" + fieldName + "datRngSelTI' >" ).insertAfter( preDefRngSelect );
	this.m_preDefRngSelectTI = $( "#" + fieldName + "datRngSelTI" ); // non-visible input for datepicker popup
	this.m_preDefRngSelectTI.css( {
		"width" : "1px",
		"height" : "1px",
		"border-style" : "none",
		"padding" : "0px",
		"background-color" : "transparent"
	} );
	this.m_preDefRngSelectTI.datepicker( {
		changeYear : true,
		yearRange : "-100:+5",
		dateFormat : dateDispFormat,
		firstDay : firstDayOfWeek
	} );
	var thisTmp = this;
	this.m_preDefRngSelectTI.datepicker( "option", "onSelect", function( date ) {
		thisTmp.m_dateBoxAfter.datepicker( "setDate", date );
		thisTmp.getInput( 'datAFTERcb' ).prop( "checked", true );
		thisTmp.m_dateBoxBefore.datepicker( "setDate", date );
		thisTmp.getInput( 'datBEFOREcb' ).prop( "checked", true );
		thisTmp.handleNudge( thisTmp.m_fieldName + 'datAFTERcb' );
	} );

	setTimeout( function() {
		thisTmp.m_dateBoxAfter.datepicker( "setDate", $.datepicker.parseDate( 'yymmdd', dateAfter ) );
		thisTmp.m_dateBoxBefore.datepicker( "setDate", $.datepicker.parseDate( 'yymmdd', dateBefore ) );
	}, 4 );

	this.getInput = function( fieldIdSuff ) {
		var id = this.m_fieldName + fieldIdSuff;
		return $( '#' + this.m_fieldName + fieldIdSuff );
	}

	/**
	 * this returns the range filter string represented by the newer/beyond/older/within section
	 */
	this.getCurrentRange = function() {
		// if ( this.getInput( 'datAFTERcb' ).is( ':checked' ) && this.getInput( 'datBEFOREcb' ).is( ':checked' ) && this.getInput( 'datAFTERbox' ).val() == this.getInput( 'datBEFOREbox' ).val() ) {
		// return "$custom$";
		// }
		var low = '';
		var isNewer = this.getInput( 'datNEWERcb' ).is( ':checked' );
		var isBeyond = this.getInput( 'datFURTHERcb' ).is( ':checked' );
		if ( isNewer || isBeyond ) {
			low = ( isBeyond ? '+' : '' ) + this.getInput( 'datNEWER' ).val() + ' ' + this.getInput( 'datNEWERunit' ).val();
		}
		var high = '';
		var isOlder = this.getInput( 'datOLDERcb' ).is( ':checked' );
		var isWithin = this.getInput( 'datCLOSERcb' ).is( ':checked' );
		if ( isOlder || isWithin ) {
			high = ( isWithin ? '+' : '' ) + this.getInput( 'datOLDER' ).val() + ' ' + this.getInput( 'datOLDERunit' ).val();
		}
		return low + '-' + high;
	};

	/**
	 * this function is to be called with one of the predefined ranges as a parameter (when the select box is changed)
	 */
	this.setCurrentRange = function( range ) {
		if ( "$custom$" == range ) {
			// show calendar which's onchange should take care of the rest.
			var pdrsti = this.m_preDefRngSelectTI;
			setTimeout( function() {
				pdrsti.datepicker( 'show' );
			}, 4 );
			return;
		}
		var triggerCB = null;
		var p = range.indexOf( '-' );
		var low = range.substr( 0, p );
		var high = range.substr( p + 1 );

		var isBeyond = low.startsWith( '+' );
		var isNewer = !isBeyond && ( low.length > 0 );
		var lowVal = '';
		var lowUnit = 'minutes';
		this.getInput( 'datFURTHERcb' ).prop( "checked", false );
		this.getInput( 'datNEWERcb' ).prop( "checked", false );
		if ( isBeyond || isNewer ) {
			if ( isBeyond ) {
				low = low.substr( 1 );
				this.getInput( 'datFURTHERcb' ).prop( "checked", true );
				triggerCB = 'datFURTHERcb';
			}
			else {
				this.getInput( 'datNEWERcb' ).prop( "checked", true );
				triggerCB = 'datNEWERcb';
			}
			p = low.indexOf( ' ' );
			lowVal = low.substr( 0, p );
			lowUnit = low.substr( p + 1 );
		}
		this.getInput( 'datNEWER' ).val( lowVal );
		this.getInput( 'datNEWERunit' ).val( lowUnit );

		var isWithin = high.startsWith( '+' );
		var isOlder = !isWithin && ( high.length > 0 );
		var highVal = '';
		varhighUnit = 'minutes';
		this.getInput( 'datCLOSERcb' ).prop( "checked", false );
		this.getInput( 'datOLDERcb' ).prop( "checked", false );
		if ( isWithin || isOlder ) {
			if ( isWithin ) {
				high = high.substr( 1 );
				this.getInput( 'datCLOSERcb' ).prop( "checked", true );
				triggerCB = 'datCLOSERcb';
			}
			else {
				this.getInput( 'datOLDERcb' ).prop( "checked", true );
				triggerCB = 'datOLDERcb';
			}
			p = high.indexOf( ' ' );
			highVal = high.substr( 0, p );
			highUnit = high.substr( p + 1 );
		}
		this.getInput( 'datOLDER' ).val( highVal );
		this.getInput( 'datOLDERunit' ).val( highUnit );
		if ( triggerCB != null ) {
			// at least checkbox is turned on, lets call it to turn any conflicting checkboxes off
			this.handleNudge( this.m_fieldName + triggerCB );
		}
	};

	/**
	 * this method handles the effects of changes/events
	 */
	this.handleNudge = function( inputID ) { // by nudge I mean focusing on input fields and toggling for checkboxes
		try {
			var idSuffix = inputID.substr( this.m_fieldName.length );
			if ( inputID.endsWith( "cb" ) ) {
				if ( !$( "#" + inputID ).is( ':checked' ) ) {
					// checkbox not checked
					return;
				}
				// turn non-compatible checkboxes off
				for (var i = 0; i < allDTCBSuffixes.length; i++) {
					var suff = allDTCBSuffixes[ i ];
					if ( suff != idSuffix && compatibleCBSuffixes[ idSuffix ].indexOf( suff ) == -1 ) {
						$( "#" + this.m_fieldName + suff ).prop( "checked", false );
					}
				}
				return;
			}
			else if ( idSuffix == 'datRngSel' ) {
				// check whether an option is selected, if not, return
				var selFilter = $( "#" + inputID ).val();
				if ( selFilter != null ) {
					this.setCurrentRange( selFilter );
				}
				return;
			}
			else {
				// text input fields (before/after/newer/older/beyond/within) come here
				// handle checkboxes
				var impCBs = dtCbImplications[ idSuffix ];
				if ( impCBs && impCBs.length > 0 ) {
					for (var i = 0; i < impCBs.length; i++) {
						if ( $( "#" + this.m_fieldName + impCBs[ i ] ).is( ':checked' ) ) {
							// a good checkbox is already checked, we're good
							return;
						}
					}
					$( "#" + this.m_fieldName + impCBs[ 0 ] ).prop( "checked", true );
					this.handleNudge( this.m_fieldName + impCBs[ 0 ] );
				}
			}
		}
		finally {
			// check currently defined filter and update preDefRagne selection accordingly
			var currentRange = this.getCurrentRange();
			$( '#' + this.m_fieldName + 'datRngSel' ).val( currentRange );
			// if relative range input was changed, update the static range
			if ( idSuffix != "datBEFOREbox" && idSuffix != "datBEFOREcb" && idSuffix != "datAFTERbox" && idSuffix != "datAFTERcb" ) {
				// also set the static range
				var p = currentRange.indexOf( '-' );
				var low = currentRange.substr( 0, p );
				var high = currentRange.substr( p + 1 );
				if ( low.length > 0 ) {
					this.m_dateBoxAfter.datepicker( 'setDate', relativeToAbsDate( low, this.m_firstDayOfWeek, false ) );
				}
				else {
					this.m_dateBoxAfter.datepicker( 'setDate', null );
				}
				if ( high.length > 0 ) {
					this.m_dateBoxBefore.datepicker( 'setDate', relativeToAbsDate( high, this.m_firstDayOfWeek, true ) );
				}
				else {
					this.m_dateBoxBefore.datepicker( 'setDate', null );
				}
			}
		}
	};

	this.handleNudge( "" ); // for selecting predefined range
};

var dTFilterHandlers = new Array();

function registerDTFilterHandler( fieldName, dateDispFormat, firstDayOfWeek ) {
	dTFilterHandlers[ fieldName ] = new DTFilterHandler( fieldName, dateDispFormat, firstDayOfWeek );
};

function dtfElementNudged( fieldName, inputID ) {
	dTFilterHandlers[ fieldName ].handleNudge( inputID );
};