<%--
 * Component: cases
 *
 * Description:
 *    Saves the viewer profile for a user.
 *
 * Parameters:
 * 
 *     USERNAME : ID of the user for the profile to be saved
 *     PROFILE  : profile data to be saved
 *
 * Last Updated     : $Author: Csaba Ijjas $
 * Update Date Time : $Date: 2016/02/24 $
 * RCS File Name    : $RCSfile: putprofilexml.jsp,v $
 * RCS Revision     : $Revision: 1.17 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
--%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
	page import="imagemed.util.Helper,imagemed.imsession.*,java.io.*,java.util.*, imagemed.jsputil.*"

%><% 

	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession(  );
	
	String strResponse = "ERROR: User not found";
	String strUserName = request.getParameter( "USERNAME" );
	String strProfileData = request.getParameter( "PROFILE" );
	String strRegCookie = sess.getSessionId(  );

	if ( strUserName == null ) {
		strUserName = sess.getUser(  ).getUserId(  );
	}

	if ( strUserName != null && strRegCookie != null ) {
		String strProfileDir = IMEnvBase.getEnv( "USERS_DATA" ) + "/" + strUserName;
		// String strProfileFile = IMEnvBase.getEnv( "PROFILE_FILE" );
		String strProfileFile = "profile.xml";
		String strTmpProfileFile = "tmp." + strProfileFile + "." + System.currentTimeMillis() + "." + Helper.getCounter();

		File fProfileDir = new File( strProfileDir );
		fProfileDir.mkdirs();
		File fProfileFile = new File( fProfileDir, strProfileFile );
		File fTmpProfileFile = new File( fProfileDir, strTmpProfileFile );
		fTmpProfileFile.createNewFile();

		try {

			if ( strProfileData == null ) {
				throw new Throwable();
			}

			if ( !fTmpProfileFile.canWrite() ) {
				throw new Throwable();
			}

			FileOutputStream fOutStream = new FileOutputStream( fTmpProfileFile );
			fOutStream.write( strProfileData.getBytes() );
			fOutStream.close();
			
			if ( !( Helper.renameToNotThrowsException( fTmpProfileFile, fProfileFile ) ) )
				throw new Throwable();
			
			DotcomToolbox.proliferateFile( fProfileFile.getAbsolutePath() );
			
			strResponse = "OK";
		}
		catch ( Throwable th ) {
			strResponse = "ERROR: Profile could not be saved";
		}

		try {
			if ( fTmpProfileFile.exists() )
				fTmpProfileFile.delete();
		}
		catch ( Throwable th ) {
		}
	}


	response.setContentType( "text/plain" );
	response.setHeader( "Pragma","no-cache" );
		
	out.println( "# SessionID: " + strRegCookie );
	out.println( "# Profile: " + strResponse );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}%>