#!/bin/sh
#
#  removesessiondirs.sh
#
#  Parameters:
#
#      $1    : user
#

[ -z $HOME ] && exit 1

. $HOME/etc/setenv.sh

res="res"
res="+${res}elle"
res="${res}r+"

sup="sup"
sup="@${sup}port"

user=$1
if [ -z $user ] ; then
    echo "missing parameter: username"
    exit 1
fi

if [ "$user" = "$sup" -o "$user" = "$res" ] ; then
	for dir in `echo $USERS_DATA/$user/Session_*` ; do
		if [ "$dir" != "$USERS_DATA/$user/Session_*" ] ; then
			find $dir -type f -atime -2 -print |grep Context_>/dev/null
			[ $? = 1 ] && rm -rf $dir
		fi
	done
else 
	rm -rf $USERS_DATA/$user/Session_*
fi

exit $?
