<%--
 * Component: imadmin
 *
 * Description:
 *   Customize pages and logos
 *
 * Parameters:
 *   op      : Upload/Confirm
 *   welcome,img1-4 : uploading files
 *   imgName1-4 : file names of uploaded in $MAIN_DATA dir
 *
 * $Author: pzahorcsek $
 * $Date: 2014/04/23 14:37:20 $
 *
 *  RCS File Name    : $RCSfile: customize.jsp,v $
 *  RCS Revision     : $Revision: 1.23 $
 *  Locked by        : $Locker:  $
 *  Symbolic name    : $Name:  $
 *  State            : $State: Exp $
--%><%@page import="com.erad.pacs.modules.gwt.session.BrowserInfo"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.common.libs.RequestInfo"%>
<%@page import="com.erad.pacs.services.usermanager.tomcat.Sessita"%>
<%@
  page
	import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,imagemed.exception.*,
  java.io.*,imagemed.http.tabs.*, java.text.*, java.util.StringTokenizer"%><%@
  page
	errorPage="../main/exceptionHandler.jsp"%>
<%!private static String customHtmlPath = null;%>
<%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();

	response.setHeader( "Pragma", "no-cache" );
	response.setHeader( "Cache-Control", "no-cache, must-revalidate" );
	response.setHeader( "Expiry-Date", "Friday, 31-Dec-70 23:59:59 GMT" );

	if ( !sess.getRights().hasAdminRight() ) { //Has no ADMIN RIGHT?
%>

<BR>
<CENTER>
	<H3>
		<%= LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) %>
	</H3>
</CENTER>
</BODY>
</HTML>
<%
	return;
	}
%><%-- -----FUNCTION---- --%><%!/**
	 * Seems to HTML fragment or not
	 * 
	 * @param source expecting text
	 *
	 * @return 0 means perhaps HTML, positive means likely HTML, negative means likely NOT HTML
	 *
	 */
	int seemsToHTML( String source ) {
		if ( source == null )
			return Integer.MIN_VALUE;
		if ( "".equals( source ) )
			return 0;

		// Search begin-end HTML tag pair

		int posLT = source.indexOf( '<' );
		while ( -1 != posLT ) {
			int posSP = source.indexOf( ' ', posLT );
			int posGT = source.indexOf( '>', posLT );
			if ( -1 == posSP )
				posSP = Integer.MAX_VALUE;
			if ( -1 == posGT )
				posGT = Integer.MAX_VALUE;
			int posEndBeginTag = Math.min( posSP, posGT );

			if ( posEndBeginTag < Integer.MAX_VALUE ) {
				String endTag = "</" + source.substring( posLT + 1, posEndBeginTag ) + ">";
				if ( -1 != source.indexOf( endTag, posEndBeginTag ) )
					return 8; //begin-end HTML tag pair found
				else
					posLT = posEndBeginTag; //continue searching from end of begin-tag
			}

			posLT = source.indexOf( '<', posLT + 1 );
		}

		if ( Helper.containsOnly( source, "\t\n\r .." + (char) 127 ) )
			return 0;

		return -8;
	}

	boolean changeFileIfUploaded( String sourceFileName, String targetFileName ) {
		if ( sourceFileName == null )
			return false;
		String content = Helper.readTextFile( sourceFileName );
		if ( content == null || "".equals( content ) )
			return false;

		File tmp = new File( sourceFileName );
		File target = new File( targetFileName );
		Helper.renameToNotThrowsException( tmp, target );
		return true; //  Changed
	}

	private String getCustomHtmlPath() {
		if ( customHtmlPath == null ) {
			customHtmlPath = IMEnvBase.getEnv( "MAIN_DATA" ) + "/" + "welcome" + IMEnv.getCompTypePrefix() + ".html";
		}
		return customHtmlPath;

	}%>
<%-- -----INIT & PROCESS---- --%>
<%
	String thisPage = "/imadmin/customize.jsp";
	MultipartParser req = new MultipartParser( request, IMEnvBase.getEnv( "TMP" ) );
	String EnvMainData = IMEnvBase.getEnv( "MAIN_DATA" ) + "/";
	String opValue = req.getParameter( "op" );

	if ( "Upload".equals( opValue ) || "Confirm".equals( opValue ) ) { //  has got modifier request
		for ( int i = 1; i < 5; i++ ) {
			String stri = String.valueOf( i );
			changeFileIfUploaded( req.getParameter( "img" + stri ),
					EnvMainData + req.getParameter( "imgName" + stri ) );
		}
		String fnWelcome = req.getParameter( "welcome" );
		if ( fnWelcome != null ) {
			String htmlCode = Helper.readTextFile( fnWelcome );
			if ( "Upload".equals( opValue ) && htmlCode != null && !"".equals( htmlCode ) ) {
				//Check HTML fragment
				String okURL = new RequestInfo( request ).getHttpxHost() + thisPage + "?op=Confirm&welcome=" + fnWelcome;
				int htmlSureness = seemsToHTML( htmlCode );
				if ( htmlSureness < 0 )
					throw new IMConfirmationException(
							"<CENTER><H2>" + LocalizedMessage.getSimpleMessage( "EXCEPTION_ERROR_HTML_SYNTAX" ) + "</H2></CENTER>",
							"imadmin/dicomsrv.jsp", "Upload Warning", null, okURL );
				else if ( htmlSureness == 0 )
					throw new IMConfirmationException(
							"<CENTER><H3>" + LocalizedMessage.getSimpleMessage( "EXCEPTION_ERROR_HTML_SYNTAX" ) + "</H3></CENTER>",
							"imadmin/dicomsrv.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_ERROR_HTML_SYNTAX_TITLE" ), null, okURL );
			}

			changeFileIfUploaded( req.getParameter( "welcome" ), getCustomHtmlPath() );
		}
	}
	else if ( "Save".equals( opValue ) ) {
		Helper.writeTextFile( getCustomHtmlPath(), req.getParameter( "taHtml" ) );
		Syslog slog = new Syslog( "mainpage", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "servermain" );
		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, sess.getUser().getUserId() + " modified the main page." );
		logEntry.log( sess, slog, Syslog.LOG_INFO );
	}

	String htmlWelcome = Helper.readTextFile( getCustomHtmlPath() );
	if ( htmlWelcome == null )
		htmlWelcome = ""; //default setting when has not got file and any modifier request
%><%-- -----HTML---- --%>
<HTML>

<HEAD>
<TITLE><%= new RequestInfo( request ).getHttpxHost() + " - " + LocalizedMessage.getSimpleMessage( "IMADMIN_CUSTOMIZE_HTMLPAGE_TITLE" )%>
</TITLE>
<%
	TabToolbox.writeIMpopup( out );
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( response.getWriter() );
	out.println( imagemed.jsputil.EditCustomHtmls.getScripts() );
%>
</HEAD>
<BODY>
	<%
		//TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicomsrv.jsp", "White");
	%>
	<table width="100%" border=1 cellpadding=0 cellspacing=0 class=BgShadow>
		<tr>
			<td colspan=2><br> &nbsp;&nbsp;<font size="4"><%= LocalizedMessage.getSimpleMessage( "IMADMIN_CUSTOMIZE_TITLE" ) %></font>
				<br> &nbsp;</td>
		</tr>
	</table>
	<CENTER>
		<FORM id=<%=EditCustomHtmls.EDIT_FORM_ID%> ENCTYPE=MULTIPART/FORM-DATA
			METHOD=POST>
			<BR>
			<TABLE class=BgLight width=100% border=1>
				<TR>
					<TD align="center"><%=imagemed.jsputil.EditCustomHtmls.getCustomizedHtmlForm( new BrowserInfo(), htmlWelcome )%>
					</TD>
				</TR>
			</TABLE>
			<I><%= LocalizedMessage.getSimpleMessage( "IMADMIN_HTML_TAG_WARNING" ) %></I><BR>
			<%= LocalizedMessage.getSimpleMessage( "IMADMIN_UPLOAD_UPLOAD_NEW_HTML" ) %>
			<INPUT type="file" name="welcome"><BR>
			<BR>

			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_OTHER", new Format[]{ null }, new Object[]{ LocalizedMessage.getSimpleMessage( "tabMain" ) }, true )%><BR>
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_IMAGE_NO", new Format[]{ null }, new Object[]{ "1" }, true )%>:<INPUT
				type="file" name="img1">
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_AS_MAIN_DATA", new Format[]{ null }, new Object[]{ IMEnvBase.getEnv( "MAIN_DATA" ) }, false ) + "/"%><INPUT
				type="text" name="imgName1" value="image1.gif"><BR>
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_IMAGE_NO", new Format[]{ null }, new Object[]{ "2" }, true )%>:<INPUT
				type="file" name="img2">
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_AS_MAIN_DATA", new Format[]{ null }, new Object[]{ IMEnvBase.getEnv( "MAIN_DATA" ) }, false ) + "/"%><INPUT
				type="text" name="imgName2" value="image2.gif"><BR>
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_IMAGE_NO", new Format[]{ null }, new Object[]{ "3" }, true )%>:<INPUT
				type="file" name="img3">
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_AS_MAIN_DATA", new Format[]{ null }, new Object[]{ IMEnvBase.getEnv( "MAIN_DATA" ) }, false ) + "/"%><INPUT
				type="text" name="imgName3" value="image3.gif"><BR>
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_IMAGE_NO", new Format[]{ null }, new Object[]{ "4" }, true )%>:<INPUT
				type="file" name="img4">
			<%=LocalizedMessage.getCompoundMessage( "IMADMIN_UPLOAD_AS_MAIN_DATA", new Format[]{ null }, new Object[]{ IMEnvBase.getEnv( "MAIN_DATA" ) }, false ) + "/"%><INPUT
				type="text" name="imgName4" value="image4.gif"><BR> <BR>
			<BR>
			<%= JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_UPLOAD", "op", "Upload" ) %>
			<a onclick="top.parent.evoNavigate('settings:')"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></a>
		</FORM>
	</CENTER>

	<%
		out.println( imagemed.jsputil.EditCustomHtmls.getHtmlCodes() );
	%>

</BODY>
</HTML>