#!/bin/sh
#
# deletegroup -g <groupid>
#

. $HOME/etc/setenv.sh

GROUPID=""
FILENAME=""
EXCEPTHOST=""

while getopts 'g:f:x:d:' OPT; do
  case $OPT in
  g) GROUPID="$OPTARG" ;;
  f) FILENAME="$OPTARG" ;;
  x) EXCEPTHOST="-x $OPTARG"
#  *) usage_ "Invalid_Parameter:$OPT" ;;
  esac   
done

[ -n "$FILENAME" -a -f "$FILENAME" ] && rm "$FILENAME"

[ -z "$GROUPID" ] && exit 1


DELETE_QUERY_FILE=$TMP/group_delete.`date +"%Y%m%d%H%M%S"`.$$

# Delete group from the database

echo "delete from $GROUPSTBL where ID='$GROUPID';" > $DELETE_QUERY_FILE
$MYSQL_HOME/bin/mysql $DBNAME < $DELETE_QUERY_FILE >/dev/null 2>/dev/null

[ $? -ne 0 ] && exit 1

# Delete group directory


[ -d "$USERS_DATA/#$GROUPID" ] && rm -fr "$USERS_DATA/#$GROUPID"


# PROLIFERATE

$DOTCOM_HOME/proliferate.sh $EXCEPTHOST -f $DELETE_QUERY_FILE -r $IMADMIN_HOME/deletegroup.sh -a -g -a "$GROUPID"

[ $? -ne 0 ] && exit 1

exit 0

